dojo.provide("dojo.dom");
dojo.require("dojo.lang");
dojo.dom.ELEMENT_NODE=1;
dojo.dom.ATTRIBUTE_NODE=2;
dojo.dom.TEXT_NODE=3;
dojo.dom.CDATA_SECTION_NODE=4;
dojo.dom.ENTITY_REFERENCE_NODE=5;
dojo.dom.ENTITY_NODE=6;
dojo.dom.PROCESSING_INSTRUCTION_NODE=7;
dojo.dom.COMMENT_NODE=8;
dojo.dom.DOCUMENT_NODE=9;
dojo.dom.DOCUMENT_TYPE_NODE=10;
dojo.dom.DOCUMENT_FRAGMENT_NODE=11;
dojo.dom.NOTATION_NODE=12;
dojo.dom.dojoml="http://www.dojotoolkit.org/2004/dojoml";
dojo.dom.xmlns={svg:"http://www.w3.org/2000/svg",smil:"http://www.w3.org/2001/SMIL20/",mml:"http://www.w3.org/1998/Math/MathML",cml:"http://www.xml-cml.org",xlink:"http://www.w3.org/1999/xlink",xhtml:"http://www.w3.org/1999/xhtml",xul:"http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul",xbl:"http://www.mozilla.org/xbl",fo:"http://www.w3.org/1999/XSL/Format",xsl:"http://www.w3.org/1999/XSL/Transform",xslt:"http://www.w3.org/1999/XSL/Transform",xi:"http://www.w3.org/2001/XInclude",xforms:"http://www.w3.org/2002/01/xforms",saxon:"http://icl.com/saxon",xalan:"http://xml.apache.org/xslt",xsd:"http://www.w3.org/2001/XMLSchema",dt:"http://www.w3.org/2001/XMLSchema-datatypes",xsi:"http://www.w3.org/2001/XMLSchema-instance",rdf:"http://www.w3.org/1999/02/22-rdf-syntax-ns#",rdfs:"http://www.w3.org/2000/01/rdf-schema#",dc:"http://purl.org/dc/elements/1.1/",dcq:"http://purl.org/dc/qualifiers/1.0","soap-env":"http://schemas.xmlsoap.org/soap/envelope/",wsdl:"http://schemas.xmlsoap.org/wsdl/",AdobeExtensions:"http://ns.adobe.com/AdobeSVGViewerExtensions/3.0/"};
dojo.dom.isNode=dojo.lang.isDomNode=function(wh){
if(typeof Element=="object"){
try{
return wh instanceof Element;
}
catch(E){
}
}else{
return wh&&!isNaN(wh.nodeType);
}
};
dojo.lang.whatAmI.custom["node"]=dojo.dom.isNode;
dojo.dom.getTagName=function(_2){
var _3=_2.tagName;
if(_3.substr(0,5).toLowerCase()!="dojo:"){
if(_3.substr(0,4).toLowerCase()=="dojo"){
return "dojo:"+_3.substring(4).toLowerCase();
}
var _4=_2.getAttribute("dojoType")||_2.getAttribute("dojotype");
if(_4){
return "dojo:"+_4.toLowerCase();
}
if((_2.getAttributeNS)&&(_2.getAttributeNS(this.dojoml,"type"))){
return "dojo:"+_2.getAttributeNS(this.dojoml,"type").toLowerCase();
}
try{
_4=_2.getAttribute("dojo:type");
}
catch(e){
}
if(_4){
return "dojo:"+_4.toLowerCase();
}
if((!dj_global["djConfig"])||(!djConfig["ignoreClassNames"])){
var _5=_2.className||_2.getAttribute("class");
if((_5)&&(_5.indexOf)&&(_5.indexOf("dojo-")!=-1)){
var _6=_5.split(" ");
for(var x=0;x<_6.length;x++){
if((_6[x].length>5)&&(_6[x].indexOf("dojo-")>=0)){
return "dojo:"+_6[x].substr(5).toLowerCase();
}
}
}
}
}
return _3.toLowerCase();
};
dojo.dom.getUniqueId=function(){
do{
var id="dj_unique_"+(++arguments.callee._idIncrement);
}while(document.getElementById(id));
return id;
};
dojo.dom.getUniqueId._idIncrement=0;
dojo.dom.firstElement=dojo.dom.getFirstChildElement=function(_9,_a){
var _b=_9.firstChild;
while(_b&&_b.nodeType!=dojo.dom.ELEMENT_NODE){
_b=_b.nextSibling;
}
if(_a&&_b&&_b.tagName&&_b.tagName.toLowerCase()!=_a.toLowerCase()){
_b=dojo.dom.nextElement(_b,_a);
}
return _b;
};
dojo.dom.lastElement=dojo.dom.getLastChildElement=function(_c,_d){
var _e=_c.lastChild;
while(_e&&_e.nodeType!=dojo.dom.ELEMENT_NODE){
_e=_e.previousSibling;
}
if(_d&&_e&&_e.tagName&&_e.tagName.toLowerCase()!=_d.toLowerCase()){
_e=dojo.dom.prevElement(_e,_d);
}
return _e;
};
dojo.dom.nextElement=dojo.dom.getNextSiblingElement=function(_f,_10){
if(!_f){
return null;
}
do{
_f=_f.nextSibling;
}while(_f&&_f.nodeType!=dojo.dom.ELEMENT_NODE);
if(_f&&_10&&_10.toLowerCase()!=_f.tagName.toLowerCase()){
return dojo.dom.nextElement(_f,_10);
}
return _f;
};
dojo.dom.prevElement=dojo.dom.getPreviousSiblingElement=function(_11,_12){
if(!_11){
return null;
}
if(_12){
_12=_12.toLowerCase();
}
do{
_11=_11.previousSibling;
}while(_11&&_11.nodeType!=dojo.dom.ELEMENT_NODE);
if(_11&&_12&&_12.toLowerCase()!=_11.tagName.toLowerCase()){
return dojo.dom.prevElement(_11,_12);
}
return _11;
};
dojo.dom.moveChildren=function(_13,_14,_15){
var _16=0;
if(_15){
while(_13.hasChildNodes()&&_13.firstChild.nodeType==dojo.dom.TEXT_NODE){
_13.removeChild(_13.firstChild);
}
while(_13.hasChildNodes()&&_13.lastChild.nodeType==dojo.dom.TEXT_NODE){
_13.removeChild(_13.lastChild);
}
}
while(_13.hasChildNodes()){
_14.appendChild(_13.firstChild);
_16++;
}
return _16;
};
dojo.dom.copyChildren=function(_17,_18,_19){
var _1a=_17.cloneNode(true);
return this.moveChildren(_1a,_18,_19);
};
dojo.dom.removeChildren=function(_1b){
var _1c=_1b.childNodes.length;
while(_1b.hasChildNodes()){
_1b.removeChild(_1b.firstChild);
}
return _1c;
};
dojo.dom.replaceChildren=function(_1d,_1e){
dojo.dom.removeChildren(_1d);
_1d.appendChild(_1e);
};
dojo.dom.removeNode=function(_1f){
if(_1f&&_1f.parentNode){
return _1f.parentNode.removeChild(_1f);
}
};
dojo.dom.getAncestors=function(_20,_21,_22){
var _23=[];
var _24=dojo.lang.isFunction(_21);
while(_20){
if(!_24||_21(_20)){
_23.push(_20);
}
if(_22&&_23.length>0){
return _23[0];
}
_20=_20.parentNode;
}
if(_22){
return null;
}
return _23;
};
dojo.dom.getAncestorsByTag=function(_25,tag,_27){
tag=tag.toLowerCase();
return dojo.dom.getAncestors(_25,function(el){
return ((el.tagName)&&(el.tagName.toLowerCase()==tag));
},_27);
};
dojo.dom.getFirstAncestorByTag=function(_29,tag){
return dojo.dom.getAncestorsByTag(_29,tag,true);
};
dojo.dom.isDescendantOf=function(_2b,_2c,_2d){
if(_2d&&_2b){
_2b=_2b.parentNode;
}
while(_2b){
if(_2b==_2c){
return true;
}
_2b=_2b.parentNode;
}
return false;
};
dojo.dom.innerXML=function(_2e){
if(_2e.innerXML){
return _2e.innerXML;
}else{
if(typeof XMLSerializer!="undefined"){
return (new XMLSerializer()).serializeToString(_2e);
}
}
};
dojo.dom.createDocumentFromText=function(str,_30){
if(!_30){
_30="text/xml";
}
if(typeof DOMParser!="undefined"){
var _31=new DOMParser();
return _31.parseFromString(str,_30);
}else{
if(typeof ActiveXObject!="undefined"){
var _32=new ActiveXObject("Microsoft.XMLDOM");
if(_32){
_32.async=false;
_32.loadXML(str);
return _32;
}else{
dojo.debug("toXml didn't work?");
}
}else{
if(document.createElement){
var tmp=document.createElement("xml");
tmp.innerHTML=str;
if(document.implementation&&document.implementation.createDocument){
var _34=document.implementation.createDocument("foo","",null);
for(var i=0;i<tmp.childNodes.length;i++){
_34.importNode(tmp.childNodes.item(i),true);
}
return _34;
}
return tmp.document&&tmp.document.firstChild?tmp.document.firstChild:tmp;
}
}
}
return null;
};
dojo.dom.prependChild=function(_36,_37){
if(_37.firstChild){
_37.insertBefore(_36,_37.firstChild);
}else{
_37.appendChild(_36);
}
return true;
};
dojo.dom.insertBefore=function(_38,ref,_3a){
if(_3a!=true&&(_38===ref||_38.nextSibling===ref)){
return false;
}
var _3b=ref.parentNode;
_3b.insertBefore(_38,ref);
return true;
};
dojo.dom.insertAfter=function(_3c,ref,_3e){
var pn=ref.parentNode;
if(ref==pn.lastChild){
if((_3e!=true)&&(_3c===ref)){
return false;
}
pn.appendChild(_3c);
}else{
return this.insertBefore(_3c,ref.nextSibling,_3e);
}
return true;
};
dojo.dom.insertAtPosition=function(_40,ref,_42){
if((!_40)||(!ref)||(!_42)){
return false;
}
switch(_42.toLowerCase()){
case "before":
return dojo.dom.insertBefore(_40,ref);
case "after":
return dojo.dom.insertAfter(_40,ref);
case "first":
if(ref.firstChild){
return dojo.dom.insertBefore(_40,ref.firstChild);
}else{
ref.appendChild(_40);
return true;
}
break;
default:
ref.appendChild(_40);
return true;
}
};
dojo.dom.insertAtIndex=function(_43,_44,_45){
var _46=_44.childNodes;
if(!_46.length){
_44.appendChild(_43);
return true;
}
var _47=null;
for(var i=0;i<_46.length;i++){
var _49=_46.item(i)["getAttribute"]?parseInt(_46.item(i).getAttribute("dojoinsertionindex")):-1;
if(_49<_45){
_47=_46.item(i);
}
}
if(_47){
return dojo.dom.insertAfter(_43,_47);
}else{
return dojo.dom.insertBefore(_43,_46.item(0));
}
};
dojo.dom.textContent=function(_4a,_4b){
if(_4b){
dojo.dom.replaceChildren(_4a,document.createTextNode(_4b));
return _4b;
}else{
var _4c="";
if(_4a==null){
return _4c;
}
for(var i=0;i<_4a.childNodes.length;i++){
switch(_4a.childNodes[i].nodeType){
case 1:
case 5:
_4c+=dojo.dom.textContent(_4a.childNodes[i]);
break;
case 3:
case 2:
case 4:
_4c+=_4a.childNodes[i].nodeValue;
break;
default:
break;
}
}
return _4c;
}
};
dojo.dom.collectionToArray=function(_4e){
dojo.deprecated("dojo.dom.collectionToArray","use dojo.lang.toArray instead");
return dojo.lang.toArray(_4e);
};
dojo.dom.hasParent=function(_4f){
if(!_4f||!_4f.parentNode||(_4f.parentNode&&!_4f.parentNode.tagName)){
return false;
}
return true;
};
dojo.dom.isTag=function(_50){
if(_50&&_50.tagName){
var arr=dojo.lang.toArray(arguments,1);
return arr[dojo.lang.find(_50.tagName,arr)]||"";
}
return "";
};

