dojo.provide("dojo.html");
dojo.require("dojo.dom");
dojo.require("dojo.style");
dojo.require("dojo.string");
dojo.lang.mixin(dojo.html,dojo.dom);
dojo.lang.mixin(dojo.html,dojo.style);
dojo.html.clearSelection=function(){
try{
if(window["getSelection"]){
if(dojo.render.html.safari){
window.getSelection().collapse();
}else{
window.getSelection().removeAllRanges();
}
}else{
if(document.selection){
if(document.selection.empty){
document.selection.empty();
}else{
if(document.selection.clear){
document.selection.clear();
}
}
}
}
return true;
}
catch(e){
dojo.debug(e);
return false;
}
};
dojo.html.disableSelection=function(_1){
_1=dojo.byId(_1)||dojo.html.body();
var h=dojo.render.html;
if(h.mozilla){
_1.style.MozUserSelect="none";
}else{
if(h.safari){
_1.style.KhtmlUserSelect="none";
}else{
if(h.ie){
_1.unselectable="on";
}else{
return false;
}
}
}
return true;
};
dojo.html.enableSelection=function(_3){
_3=dojo.byId(_3)||dojo.html.body();
var h=dojo.render.html;
if(h.mozilla){
_3.style.MozUserSelect="";
}else{
if(h.safari){
_3.style.KhtmlUserSelect="";
}else{
if(h.ie){
_3.unselectable="off";
}else{
return false;
}
}
}
return true;
};
dojo.html.selectElement=function(_5){
_5=dojo.byId(_5);
if(document.selection&&dojo.html.body().createTextRange){
var _6=dojo.html.body().createTextRange();
_6.moveToElementText(_5);
_6.select();
}else{
if(window["getSelection"]){
var _7=window.getSelection();
if(_7["selectAllChildren"]){
_7.selectAllChildren(_5);
}
}
}
};
dojo.html.isSelectionCollapsed=function(){
if(document["selection"]){
return document.selection.createRange().text=="";
}else{
if(window["getSelection"]){
var _8=window.getSelection();
if(dojo.lang.isString(_8)){
return _8=="";
}else{
return _8.isCollapsed;
}
}
}
};
dojo.html.getEventTarget=function(_9){
if(!_9){
_9=window.event||{};
}
if(_9.srcElement){
return _9.srcElement;
}else{
if(_9.target){
return _9.target;
}
}
return null;
};
dojo.html.getScrollTop=function(){
return document.documentElement.scrollTop||dojo.html.body().scrollTop||0;
};
dojo.html.getScrollLeft=function(){
return document.documentElement.scrollLeft||dojo.html.body().scrollLeft||0;
};
dojo.html.getDocumentWidth=function(){
dojo.deprecated("dojo.html.getDocument* has been deprecated in favor of dojo.html.getViewport*");
return dojo.html.getViewportWidth();
};
dojo.html.getDocumentHeight=function(){
dojo.deprecated("dojo.html.getDocument* has been deprecated in favor of dojo.html.getViewport*");
return dojo.html.getViewportHeight();
};
dojo.html.getDocumentSize=function(){
dojo.deprecated("dojo.html.getDocument* has been deprecated in favor of dojo.html.getViewport*");
return dojo.html.getViewportSize();
};
dojo.html.getViewportWidth=function(){
var w=0;
if(window.innerWidth){
w=window.innerWidth;
}
if(dojo.exists(document,"documentElement.clientWidth")){
var w2=document.documentElement.clientWidth;
if(!w||w2&&w2<w){
w=w2;
}
return w;
}
if(document.body){
return document.body.clientWidth;
}
return 0;
};
dojo.html.getViewportHeight=function(){
if(window.innerHeight){
return window.innerHeight;
}
if(dojo.exists(document,"documentElement.clientHeight")){
return document.documentElement.clientHeight;
}
if(document.body){
return document.body.clientHeight;
}
return 0;
};
dojo.html.getViewportSize=function(){
var _c=[dojo.html.getViewportWidth(),dojo.html.getViewportHeight()];
_c.w=_c[0];
_c.h=_c[1];
return _c;
};
dojo.html.getScrollOffset=function(){
var _d=[0,0];
if(window.pageYOffset){
_d=[window.pageXOffset,window.pageYOffset];
}else{
if(dojo.exists(document,"documentElement.scrollTop")){
_d=[document.documentElement.scrollLeft,document.documentElement.scrollTop];
}else{
if(document.body){
_d=[document.body.scrollLeft,document.body.scrollTop];
}
}
}
_d.x=_d[0];
_d.y=_d[1];
return _d;
};
dojo.html.getParentOfType=function(_e,_f){
dojo.deprecated("dojo.html.getParentOfType has been deprecated in favor of dojo.html.getParentByType*");
return dojo.html.getParentByType(_e,_f);
};
dojo.html.getParentByType=function(_10,_11){
var _12=dojo.byId(_10);
_11=_11.toLowerCase();
while((_12)&&(_12.nodeName.toLowerCase()!=_11)){
if(_12==(document["body"]||document["documentElement"])){
return null;
}
_12=_12.parentNode;
}
return _12;
};
dojo.html.getAttribute=function(_13,_14){
_13=dojo.byId(_13);
if((!_13)||(!_13.getAttribute)){
return null;
}
var ta=typeof _14=="string"?_14:new String(_14);
var v=_13.getAttribute(ta.toUpperCase());
if((v)&&(typeof v=="string")&&(v!="")){
return v;
}
if(v&&v.value){
return v.value;
}
if((_13.getAttributeNode)&&(_13.getAttributeNode(ta))){
return (_13.getAttributeNode(ta)).value;
}else{
if(_13.getAttribute(ta)){
return _13.getAttribute(ta);
}else{
if(_13.getAttribute(ta.toLowerCase())){
return _13.getAttribute(ta.toLowerCase());
}
}
}
return null;
};
dojo.html.hasAttribute=function(_17,_18){
_17=dojo.byId(_17);
return dojo.html.getAttribute(_17,_18)?true:false;
};
dojo.html.getClass=function(_19){
_19=dojo.byId(_19);
if(!_19){
return "";
}
var cs="";
if(_19.className){
cs=_19.className;
}else{
if(dojo.html.hasAttribute(_19,"class")){
cs=dojo.html.getAttribute(_19,"class");
}
}
return dojo.string.trim(cs);
};
dojo.html.getClasses=function(_1b){
_1b=dojo.byId(_1b);
var c=dojo.html.getClass(_1b);
return (c=="")?[]:c.split(/\s+/g);
};
dojo.html.hasClass=function(_1d,_1e){
_1d=dojo.byId(_1d);
return dojo.lang.inArray(dojo.html.getClasses(_1d),_1e);
};
dojo.html.prependClass=function(_1f,_20){
_1f=dojo.byId(_1f);
if(!_1f){
return false;
}
_20+=" "+dojo.html.getClass(_1f);
return dojo.html.setClass(_1f,_20);
};
dojo.html.addClass=function(_21,_22){
_21=dojo.byId(_21);
if(!_21){
return false;
}
if(dojo.html.hasClass(_21,_22)){
return false;
}
_22=dojo.string.trim(dojo.html.getClass(_21)+" "+_22);
return dojo.html.setClass(_21,_22);
};
dojo.html.setClass=function(_23,_24){
_23=dojo.byId(_23);
if(!_23){
return false;
}
var cs=new String(_24);
try{
if(typeof _23.className=="string"){
_23.className=cs;
}else{
if(_23.setAttribute){
_23.setAttribute("class",_24);
_23.className=cs;
}else{
return false;
}
}
}
catch(e){
dojo.debug("dojo.html.setClass() failed",e);
}
return true;
};
dojo.html.removeClass=function(_26,_27,_28){
_26=dojo.byId(_26);
if(!_26){
return false;
}
var _27=dojo.string.trim(new String(_27));
try{
var cs=dojo.html.getClasses(_26);
var nca=[];
if(_28){
for(var i=0;i<cs.length;i++){
if(cs[i].indexOf(_27)==-1){
nca.push(cs[i]);
}
}
}else{
for(var i=0;i<cs.length;i++){
if(cs[i]!=_27){
nca.push(cs[i]);
}
}
}
dojo.html.setClass(_26,nca.join(" "));
}
catch(e){
dojo.debug("dojo.html.removeClass() failed",e);
}
return true;
};
dojo.html.replaceClass=function(_2c,_2d,_2e){
_2c=dojo.byId(_2c);
dojo.html.removeClass(_2c,_2e);
dojo.html.addClass(_2c,_2d);
};
dojo.html.classMatchType={ContainsAll:0,ContainsAny:1,IsOnly:2};
dojo.html.getElementsByClass=function(_2f,_30,_31,_32){
_30=dojo.byId(_30);
if(!_30){
_30=document;
}
var _33=_2f.split(/\s+/g);
var _34=[];
if(_32!=1&&_32!=2){
_32=0;
}
var _35=new RegExp("(\\s|^)(("+_33.join(")|(")+"))(\\s|$)");
if(!_31){
_31="*";
}
var _36=_30.getElementsByTagName(_31);
outer:
for(var i=0;i<_36.length;i++){
var _38=_36[i];
var _39=dojo.html.getClasses(_38);
if(_39.length==0){
continue outer;
}
var _3a=0;
for(var j=0;j<_39.length;j++){
if(_35.test(_39[j])){
if(_32==dojo.html.classMatchType.ContainsAny){
_34.push(_38);
continue outer;
}else{
_3a++;
}
}else{
if(_32==dojo.html.classMatchType.IsOnly){
continue outer;
}
}
}
if(_3a==_33.length){
if(_32==dojo.html.classMatchType.IsOnly&&_3a==_39.length){
_34.push(_38);
}else{
if(_32==dojo.html.classMatchType.ContainsAll){
_34.push(_38);
}
}
}
}
return _34;
};
dojo.html.getElementsByClassName=dojo.html.getElementsByClass;
dojo.html.gravity=function(_3c,e){
_3c=dojo.byId(_3c);
var _3e=e.pageX||e.clientX+dojo.html.body().scrollLeft;
var _3f=e.pageY||e.clientY+dojo.html.body().scrollTop;
with(dojo.html){
var _40=getAbsoluteX(_3c)+(getInnerWidth(_3c)/2);
var _41=getAbsoluteY(_3c)+(getInnerHeight(_3c)/2);
}
with(dojo.html.gravity){
return ((_3e<_40?WEST:EAST)|(_3f<_41?NORTH:SOUTH));
}
};
dojo.html.gravity.NORTH=1;
dojo.html.gravity.SOUTH=1<<1;
dojo.html.gravity.EAST=1<<2;
dojo.html.gravity.WEST=1<<3;
dojo.html.overElement=function(_42,e){
_42=dojo.byId(_42);
var _44=e.pageX||e.clientX+dojo.html.body().scrollLeft;
var _45=e.pageY||e.clientY+dojo.html.body().scrollTop;
with(dojo.html){
var top=getAbsoluteY(_42);
var _47=top+getInnerHeight(_42);
var _48=getAbsoluteX(_42);
var _49=_48+getInnerWidth(_42);
}
return (_44>=_48&&_44<=_49&&_45>=top&&_45<=_47);
};
dojo.html.renderedTextContent=function(_4a){
_4a=dojo.byId(_4a);
var _4b="";
if(_4a==null){
return _4b;
}
for(var i=0;i<_4a.childNodes.length;i++){
switch(_4a.childNodes[i].nodeType){
case 1:
case 5:
var _4d="unknown";
try{
_4d=dojo.style.getStyle(_4a.childNodes[i],"display");
}
catch(E){
}
switch(_4d){
case "block":
case "list-item":
case "run-in":
case "table":
case "table-row-group":
case "table-header-group":
case "table-footer-group":
case "table-row":
case "table-column-group":
case "table-column":
case "table-cell":
case "table-caption":
_4b+="\n";
_4b+=dojo.html.renderedTextContent(_4a.childNodes[i]);
_4b+="\n";
break;
case "none":
break;
default:
if(_4a.childNodes[i].tagName&&_4a.childNodes[i].tagName.toLowerCase()=="br"){
_4b+="\n";
}else{
_4b+=dojo.html.renderedTextContent(_4a.childNodes[i]);
}
break;
}
break;
case 3:
case 2:
case 4:
var _4e=_4a.childNodes[i].nodeValue;
var _4f="unknown";
try{
_4f=dojo.style.getStyle(_4a,"text-transform");
}
catch(E){
}
switch(_4f){
case "capitalize":
_4e=dojo.string.capitalize(_4e);
break;
case "uppercase":
_4e=_4e.toUpperCase();
break;
case "lowercase":
_4e=_4e.toLowerCase();
break;
default:
break;
}
switch(_4f){
case "nowrap":
break;
case "pre-wrap":
break;
case "pre-line":
break;
case "pre":
break;
default:
_4e=_4e.replace(/\s+/," ");
if(/\s$/.test(_4b)){
_4e.replace(/^\s/,"");
}
break;
}
_4b+=_4e;
break;
default:
break;
}
}
return _4b;
};
dojo.html.setActiveStyleSheet=function(_50){
var i,a,main;
for(i=0;(a=document.getElementsByTagName("link")[i]);i++){
if(a.getAttribute("rel").indexOf("style")!=-1&&a.getAttribute("title")){
a.disabled=true;
if(a.getAttribute("title")==_50){
a.disabled=false;
}
}
}
};
dojo.html.getActiveStyleSheet=function(){
var i,a;
for(i=0;(a=document.getElementsByTagName("link")[i]);i++){
if(a.getAttribute("rel").indexOf("style")!=-1&&a.getAttribute("title")&&!a.disabled){
return a.getAttribute("title");
}
}
return null;
};
dojo.html.getPreferredStyleSheet=function(){
var i,a;
for(i=0;(a=document.getElementsByTagName("link")[i]);i++){
if(a.getAttribute("rel").indexOf("style")!=-1&&a.getAttribute("rel").indexOf("alt")==-1&&a.getAttribute("title")){
return a.getAttribute("title");
}
}
return null;
};
dojo.html.body=function(){
return document.body||document.getElementsByTagName("body")[0];
};
dojo.html.createNodesFromText=function(txt,_55){
if(_55){
txt=dojo.string.trim(txt);
}
var tn=document.createElement("div");
tn.style.visibility="hidden";
document.body.appendChild(tn);
var _57="none";
if((/^<t[dh][\s\r\n>]/i).test(dojo.string.trimStart(txt))){
txt="<table><tbody><tr>"+txt+"</tr></tbody></table>";
_57="cell";
}else{
if((/^<tr[\s\r\n>]/i).test(dojo.string.trimStart(txt))){
txt="<table><tbody>"+txt+"</tbody></table>";
_57="row";
}else{
if((/^<(thead|tbody|tfoot)[\s\r\n>]/i).test(dojo.string.trimStart(txt))){
txt="<table>"+txt+"</table>";
_57="section";
}
}
}
tn.innerHTML=txt;
tn.normalize();
var _58=null;
switch(_57){
case "cell":
_58=tn.getElementsByTagName("tr")[0];
break;
case "row":
_58=tn.getElementsByTagName("tbody")[0];
break;
case "section":
_58=tn.getElementsByTagName("table")[0];
break;
default:
_58=tn;
break;
}
var _59=[];
for(var x=0;x<_58.childNodes.length;x++){
_59.push(_58.childNodes[x].cloneNode(true));
}
tn.style.display="none";
document.body.removeChild(tn);
return _59;
};
if(!dojo.evalObjPath("dojo.dom.createNodesFromText")){
dojo.dom.createNodesFromText=function(){
dojo.deprecated("dojo.dom.createNodesFromText","use dojo.html.createNodesFromText instead");
return dojo.html.createNodesFromText.apply(dojo.html,arguments);
};
}
dojo.html.isVisible=function(_5b){
_5b=dojo.byId(_5b);
return dojo.style.getComputedStyle(_5b||this.domNode,"display")!="none";
};
dojo.html.show=function(_5c){
_5c=dojo.byId(_5c);
if(_5c.style){
_5c.style.display=dojo.lang.inArray(["tr","td","th"],_5c.tagName.toLowerCase())?"":"block";
}
};
dojo.html.hide=function(_5d){
_5d=dojo.byId(_5d);
if(_5d.style){
_5d.style.display="none";
}
};
dojo.html.toggleVisible=function(_5e){
if(dojo.html.isVisible(_5e)){
dojo.html.hide(_5e);
return false;
}else{
dojo.html.show(_5e);
return true;
}
};
dojo.html.isTag=function(_5f){
_5f=dojo.byId(_5f);
if(_5f&&_5f.tagName){
var arr=dojo.lang.map(dojo.lang.toArray(arguments,1),function(a){
return String(a).toLowerCase();
});
return arr[dojo.lang.find(_5f.tagName.toLowerCase(),arr)]||"";
}
return "";
};
dojo.html.toCoordinateArray=function(_62,_63){
if(dojo.lang.isArray(_62)){
while(_62.length<4){
_62.push(0);
}
while(_62.length>4){
_62.pop();
}
var ret=_62;
}else{
var _65=dojo.byId(_62);
var ret=[dojo.html.getAbsoluteX(_65,_63),dojo.html.getAbsoluteY(_65,_63),dojo.html.getInnerWidth(_65),dojo.html.getInnerHeight(_65)];
}
ret.x=ret[0];
ret.y=ret[1];
ret.w=ret[2];
ret.h=ret[3];
return ret;
};
dojo.html.placeOnScreen=function(_66,_67,_68,_69,_6a){
if(dojo.lang.isArray(_67)){
_6a=_69;
_69=_68;
_68=_67[1];
_67=_67[0];
}
if(!isNaN(_69)){
_69=[Number(_69),Number(_69)];
}else{
if(!dojo.lang.isArray(_69)){
_69=[0,0];
}
}
var _6b=dojo.html.getScrollOffset();
var _6c=dojo.html.getViewportSize();
_66=dojo.byId(_66);
var w=_66.offsetWidth+_69[0];
var h=_66.offsetHeight+_69[1];
if(_6a){
_67-=_6b.x;
_68-=_6b.y;
}
var x=_67+w;
if(x>_6c.w){
x=_6c.w-w;
}else{
x=_67;
}
x=Math.max(_69[0],x)+_6b.x;
var y=_68+h;
if(y>_6c.h){
y=_6c.h-h;
}else{
y=_68;
}
y=Math.max(_69[1],y)+_6b.y;
_66.style.left=x+"px";
_66.style.top=y+"px";
var ret=[x,y];
ret.x=x;
ret.y=y;
return ret;
};
dojo.html.placeOnScreenPoint=function(_72,_73,_74,_75,_76){
if(dojo.lang.isArray(_73)){
_76=_75;
_75=_74;
_74=_73[1];
_73=_73[0];
}
var _77=dojo.html.getScrollOffset();
var _78=dojo.html.getViewportSize();
_72=dojo.byId(_72);
var w=_72.offsetWidth;
var h=_72.offsetHeight;
if(_76){
_73-=_77.x;
_74-=_77.y;
}
var x=-1,y=-1;
if(_73+w<=_78.w&&_74+h<=_78.h){
x=_73;
y=_74;
}
if((x<0||y<0)&&_73<=_78.w&&_74+h<=_78.h){
x=_73-w;
y=_74;
}
if((x<0||y<0)&&_73+w<=_78.w&&_74<=_78.h){
x=_73;
y=_74-h;
}
if((x<0||y<0)&&_73<=_78.w&&_74<=_78.h){
x=_73-w;
y=_74-h;
}
if(x<0||y<0||(x+w>_78.w)||(y+h>_78.h)){
return dojo.html.placeOnScreen(_72,_73,_74,_75,_76);
}
x+=_77.x;
y+=_77.y;
_72.style.left=x+"px";
_72.style.top=y+"px";
var ret=[x,y];
ret.x=x;
ret.y=y;
return ret;
};
dojo.html.BackgroundIframe=function(){
if(this.ie){
this.iframe=document.createElement("<iframe frameborder='0' src='about:blank'>");
var s=this.iframe.style;
s.position="absolute";
s.left=s.top="0px";
s.zIndex=2;
s.display="none";
dojo.style.setOpacity(this.iframe,0);
dojo.html.body().appendChild(this.iframe);
}else{
this.enabled=false;
}
};
dojo.lang.extend(dojo.html.BackgroundIframe,{ie:dojo.render.html.ie,enabled:true,visibile:false,iframe:null,sizeNode:null,sizeCoords:null,size:function(_7e){
if(!this.ie||!this.enabled){
return;
}
if(dojo.dom.isNode(_7e)){
this.sizeNode=_7e;
}else{
if(arguments.length>0){
this.sizeNode=null;
this.sizeCoords=_7e;
}
}
this.update();
},update:function(){
if(!this.ie||!this.enabled){
return;
}
if(this.sizeNode){
this.sizeCoords=dojo.html.toCoordinateArray(this.sizeNode,true);
}else{
if(this.sizeCoords){
this.sizeCoords=dojo.html.toCoordinateArray(this.sizeCoords,true);
}else{
return;
}
}
var s=this.iframe.style;
var _80=this.sizeCoords;
s.width=_80.w+"px";
s.height=_80.h+"px";
s.left=_80.x+"px";
s.top=_80.y+"px";
},setZIndex:function(_81){
if(!this.ie||!this.enabled){
return;
}
if(dojo.dom.isNode(_81)){
this.iframe.zIndex=dojo.html.getStyle(_81,"z-index")-1;
}else{
if(!isNaN(_81)){
this.iframe.zIndex=_81;
}
}
},show:function(_82){
if(!this.ie||!this.enabled){
return;
}
this.size(_82);
this.iframe.style.display="block";
},hide:function(){
if(!this.ie){
return;
}
var s=this.iframe.style;
s.display="none";
s.width=s.height="1px";
},remove:function(){
dojo.dom.removeNode(this.iframe);
}});

