dojo.provide("dojo.rpc.Deferred");
dojo.require("dojo.lang");
dojo.rpc.Deferred=function(_1){
this.chain=[];
this.id=this._nextId();
this.fired=-1;
this.paused=0;
this.results=[null,null];
this.canceller=_1;
this.silentlyCancelled=false;
};
dojo.lang.extend(dojo.rpc.Deferred,{getFunctionFromArgs:function(){
var a=arguments;
if((a[0])&&(!a[1])){
if(dojo.lang.isFunction(a[0])){
return a[0];
}else{
if(dojo.lang.isString(a[0])){
return dj_global[a[0]];
}
}
}else{
if((a[0])&&(a[1])){
return dojo.lang.hitch(a[0],a[1]);
}
}
return null;
},repr:function(){
var _3;
if(this.fired==-1){
_3="unfired";
}else{
if(this.fired==0){
_3="success";
}else{
_3="error";
}
}
return "Deferred("+this.id+", "+_3+")";
},toString:dojo.lang.forward("repr"),_nextId:(function(){
var n=1;
return function(){
return n++;
};
})(),cancel:function(){
if(this.fired==-1){
if(this.canceller){
this.canceller(this);
}else{
this.silentlyCancelled=true;
}
if(this.fired==-1){
this.errback(new Error(this.repr()));
}
}else{
if((this.fired==0)&&(this.results[0] instanceof dojo.rpc.Deferred)){
this.results[0].cancel();
}
}
},_pause:function(){
this.paused++;
},_unpause:function(){
this.paused--;
if((this.paused==0)&&(this.fired>=0)){
this._fire();
}
},_continue:function(_5){
this._resback(_5);
this._unpause();
},_resback:function(_6){
this.fired=((_6 instanceof Error)?1:0);
this.results[this.fired]=_6;
this._fire();
},_check:function(){
if(this.fired!=-1){
if(!this.silentlyCancelled){
dojo.raise("already called!");
}
this.silentlyCancelled=false;
return;
}
},callback:function(_7){
this._check();
this._resback(_7);
},errback:function(_8){
this._check();
if(!(_8 instanceof Error)){
_8=new Error(_8);
}
this._resback(_8);
},addBoth:function(cb,_a){
var _b=this.getFunctionFromArgs(cb,_a);
if(arguments.length>2){
_b=dojo.lang.curryArguments(null,_b,arguments,2);
}
return this.addCallbacks(_b,_b);
},addCallback:function(cb,_d){
var _e=this.getFunctionFromArgs(cb,_d);
if(arguments.length>2){
_e=dojo.lang.curryArguments(null,_e,arguments,2);
}
return this.addCallbacks(_e,null);
},addErrback:function(cb,_10){
var _11=this.getFunctionFromArgs(cb,_10);
if(arguments.length>2){
_11=dojo.lang.curryArguments(null,_11,arguments,2);
}
return this.addCallbacks(null,_11);
return this.addCallbacks(null,fn);
},addCallbacks:function(cb,eb){
this.chain.push([cb,eb]);
if(this.fired>=0){
this._fire();
}
return this;
},_fire:function(){
var _14=this.chain;
var _15=this.fired;
var res=this.results[_15];
var _17=this;
var cb=null;
while(_14.length>0&&this.paused==0){
var _19=_14.shift();
var f=_19[_15];
if(f==null){
continue;
}
try{
res=f(res);
_15=((res instanceof Error)?1:0);
if(res instanceof dojo.rpc.Deferred){
cb=function(res){
_17._continue(res);
};
this._pause();
}
}
catch(err){
_15=1;
res=err;
}
}
this.fired=_15;
this.results[_15]=res;
if((cb)&&(this.paused)){
res.addBoth(cb);
}
}});

