dojo.provide("dojo.style");
dojo.require("dojo.dom");
dojo.require("dojo.uri.Uri");
dojo.require("dojo.graphics.color");
dojo.style.boxSizing={marginBox:"margin-box",borderBox:"border-box",paddingBox:"padding-box",contentBox:"content-box"};
dojo.style.getBoxSizing=function(_1){
if(dojo.render.html.ie||dojo.render.html.opera){
var cm=document["compatMode"];
if(cm=="BackCompat"||cm=="QuirksMode"){
return dojo.style.boxSizing.borderBox;
}else{
return dojo.style.boxSizing.contentBox;
}
}else{
if(arguments.length==0){
_1=document.documentElement;
}
var _3=dojo.style.getStyle(_1,"-moz-box-sizing");
if(!_3){
_3=dojo.style.getStyle(_1,"box-sizing");
}
return (_3?_3:dojo.style.boxSizing.contentBox);
}
};
dojo.style.isBorderBox=function(_4){
return (dojo.style.getBoxSizing(_4)==dojo.style.boxSizing.borderBox);
};
dojo.style.getUnitValue=function(_5,_6,_7){
var _8={value:0,units:"px"};
var s=dojo.style.getComputedStyle(_5,_6);
if(s==""||(s=="auto"&&_7)){
return _8;
}
if(dojo.lang.isUndefined(s)){
_8.value=NaN;
}else{
var _a=s.match(/([\d.]+)([a-z%]*)/i);
if(!_a){
_8.value=NaN;
}else{
_8.value=Number(_a[1]);
_8.units=_a[2].toLowerCase();
}
}
return _8;
};
dojo.style.getPixelValue=function(_b,_c,_d){
var _e=dojo.style.getUnitValue(_b,_c,_d);
if(isNaN(_e.value)){
return 0;
}
if((_e.value)&&(_e.units!="px")){
return NaN;
}
return _e.value;
};
dojo.style.getNumericStyle=dojo.style.getPixelValue;
dojo.style.isPositionAbsolute=function(_f){
return (dojo.style.getComputedStyle(_f,"position")=="absolute");
};
dojo.style.getMarginWidth=function(_10){
var _11=dojo.style.isPositionAbsolute(_10);
var _12=dojo.style.getPixelValue(_10,"margin-left",_11);
var _13=dojo.style.getPixelValue(_10,"margin-right",_11);
return _12+_13;
};
dojo.style.getBorderWidth=function(_14){
var _15=(dojo.style.getStyle(_14,"border-left-style")=="none"?0:dojo.style.getPixelValue(_14,"border-left-width"));
var _16=(dojo.style.getStyle(_14,"border-right-style")=="none"?0:dojo.style.getPixelValue(_14,"border-right-width"));
return _15+_16;
};
dojo.style.getPaddingWidth=function(_17){
var _18=dojo.style.getPixelValue(_17,"padding-left",true);
var _19=dojo.style.getPixelValue(_17,"padding-right",true);
return _18+_19;
};
dojo.style.getContentWidth=function(_1a){
return _1a.offsetWidth-dojo.style.getPaddingWidth(_1a)-dojo.style.getBorderWidth(_1a);
};
dojo.style.getInnerWidth=function(_1b){
return _1b.offsetWidth;
};
dojo.style.getOuterWidth=function(_1c){
return dojo.style.getInnerWidth(_1c)+dojo.style.getMarginWidth(_1c);
};
dojo.style.setOuterWidth=function(_1d,_1e){
if(!dojo.style.isBorderBox(_1d)){
_1e-=dojo.style.getPaddingWidth(_1d)+dojo.style.getBorderWidth(_1d);
}
_1e-=dojo.style.getMarginWidth(_1d);
if(!isNaN(_1e)&&_1e>0){
_1d.style.width=_1e+"px";
return true;
}else{
return false;
}
};
dojo.style.getContentBoxWidth=dojo.style.getContentWidth;
dojo.style.getBorderBoxWidth=dojo.style.getInnerWidth;
dojo.style.getMarginBoxWidth=dojo.style.getOuterWidth;
dojo.style.setMarginBoxWidth=dojo.style.setOuterWidth;
dojo.style.getMarginHeight=function(_1f){
var _20=dojo.style.isPositionAbsolute(_1f);
var top=dojo.style.getPixelValue(_1f,"margin-top",_20);
var _22=dojo.style.getPixelValue(_1f,"margin-bottom",_20);
return top+_22;
};
dojo.style.getBorderHeight=function(_23){
var top=(dojo.style.getStyle(_23,"border-top-style")=="none"?0:dojo.style.getPixelValue(_23,"border-top-width"));
var _25=(dojo.style.getStyle(_23,"border-bottom-style")=="none"?0:dojo.style.getPixelValue(_23,"border-bottom-width"));
return top+_25;
};
dojo.style.getPaddingHeight=function(_26){
var top=dojo.style.getPixelValue(_26,"padding-top",true);
var _28=dojo.style.getPixelValue(_26,"padding-bottom",true);
return top+_28;
};
dojo.style.getContentHeight=function(_29){
return _29.offsetHeight-dojo.style.getPaddingHeight(_29)-dojo.style.getBorderHeight(_29);
};
dojo.style.getInnerHeight=function(_2a){
return _2a.offsetHeight;
};
dojo.style.getOuterHeight=function(_2b){
return dojo.style.getInnerHeight(_2b)+dojo.style.getMarginHeight(_2b);
};
dojo.style.setOuterHeight=function(_2c,_2d){
if(!dojo.style.isBorderBox(_2c)){
_2d-=dojo.style.getPaddingHeight(_2c)+dojo.style.getBorderHeight(_2c);
}
_2d-=dojo.style.getMarginHeight(_2c);
if(!isNaN(_2d)&&_2d>0){
_2c.style.height=_2d+"px";
return true;
}else{
return false;
}
};
dojo.style.setContentWidth=function(_2e,_2f){
if(dojo.style.isBorderBox(_2e)){
_2f+=dojo.style.getPaddingWidth(_2e)+dojo.style.getBorderWidth(_2e);
}
if(!isNaN(_2f)&&_2f>0){
_2e.style.width=_2f+"px";
return true;
}else{
return false;
}
};
dojo.style.setContentHeight=function(_30,_31){
if(dojo.style.isBorderBox(_30)){
_31+=dojo.style.getPaddingHeight(_30)+dojo.style.getBorderHeight(_30);
}
if(!isNaN(_31)&&_31>0){
_30.style.height=_31+"px";
return true;
}else{
return false;
}
};
dojo.style.getContentBoxHeight=dojo.style.getContentHeight;
dojo.style.getBorderBoxHeight=dojo.style.getInnerHeight;
dojo.style.getMarginBoxHeight=dojo.style.getOuterHeight;
dojo.style.setMarginBoxHeight=dojo.style.setOuterHeight;
dojo.style.getTotalOffset=function(_32,_33,_34){
var _35=(_33=="top")?"offsetTop":"offsetLeft";
var _36=(_33=="top")?"scrollTop":"scrollLeft";
var _37=(_33=="top")?"y":"x";
var _38=0;
if(_32["offsetParent"]){
if(dojo.render.html.safari&&_32.style.getPropertyValue("position")=="absolute"&&_32.parentNode==dojo.html.body()){
var _39=dojo.html.body();
}else{
var _39=dojo.html.body().parentNode;
}
if(_34&&_32.parentNode!=document.body){
_38-=dojo.style.sumAncestorProperties(_32,_36);
}
do{
_38+=_32[_35];
_32=_32.offsetParent;
}while(_32!=_39&&_32!=null);
}else{
if(_32[_37]){
_38+=_32[_37];
}
}
return _38;
};
dojo.style.sumAncestorProperties=function(_3a,_3b){
if(!_3a){
return 0;
}
var _3c=0;
while(_3a){
var val=_3a[_3b];
if(val){
_3c+=val-0;
}
_3a=_3a.parentNode;
}
return _3c;
};
dojo.style.totalOffsetLeft=function(_3e,_3f){
return dojo.style.getTotalOffset(_3e,"left",_3f);
};
dojo.style.getAbsoluteX=dojo.style.totalOffsetLeft;
dojo.style.totalOffsetTop=function(_40,_41){
return dojo.style.getTotalOffset(_40,"top",_41);
};
dojo.style.getAbsoluteY=dojo.style.totalOffsetTop;
dojo.style.getAbsolutePosition=function(_42,_43){
var _44=[dojo.style.getAbsoluteX(_42,_43),dojo.style.getAbsoluteY(_42,_43)];
_44.x=_44[0];
_44.y=_44[1];
return _44;
};
dojo.style.styleSheet=null;
dojo.style.insertCssRule=function(_45,_46,_47){
if(!dojo.style.styleSheet){
if(document.createStyleSheet){
dojo.style.styleSheet=document.createStyleSheet();
}else{
if(document.styleSheets[0]){
dojo.style.styleSheet=document.styleSheets[0];
}else{
return null;
}
}
}
if(arguments.length<3){
if(dojo.style.styleSheet.cssRules){
_47=dojo.style.styleSheet.cssRules.length;
}else{
if(dojo.style.styleSheet.rules){
_47=dojo.style.styleSheet.rules.length;
}else{
return null;
}
}
}
if(dojo.style.styleSheet.insertRule){
var _48=_45+" { "+_46+" }";
return dojo.style.styleSheet.insertRule(_48,_47);
}else{
if(dojo.style.styleSheet.addRule){
return dojo.style.styleSheet.addRule(_45,_46,_47);
}else{
return null;
}
}
};
dojo.style.removeCssRule=function(_49){
if(!dojo.style.styleSheet){
dojo.debug("no stylesheet defined for removing rules");
return false;
}
if(dojo.render.html.ie){
if(!_49){
_49=dojo.style.styleSheet.rules.length;
dojo.style.styleSheet.removeRule(_49);
}
}else{
if(document.styleSheets[0]){
if(!_49){
_49=dojo.style.styleSheet.cssRules.length;
}
dojo.style.styleSheet.deleteRule(_49);
}
}
return true;
};
dojo.style.insertCssFile=function(URI,doc,_4c){
if(!URI){
return;
}
if(!doc){
doc=document;
}
if(doc.baseURI){
URI=new dojo.uri.Uri(doc.baseURI,URI);
}
if(_4c&&doc.styleSheets){
var loc=location.href.split("#")[0].substring(0,location.href.indexOf(location.pathname));
for(var i=0;i<doc.styleSheets.length;i++){
if(doc.styleSheets[i].href&&URI.toString()==new dojo.uri.Uri(doc.styleSheets[i].href.toString())){
return;
}
}
}
var _4f=doc.createElement("link");
_4f.setAttribute("type","text/css");
_4f.setAttribute("rel","stylesheet");
_4f.setAttribute("href",URI);
var _50=doc.getElementsByTagName("head")[0];
if(_50){
_50.appendChild(_4f);
}
};
dojo.style.getBackgroundColor=function(_51){
var _52;
do{
_52=dojo.style.getStyle(_51,"background-color");
if(_52.toLowerCase()=="rgba(0, 0, 0, 0)"){
_52="transparent";
}
if(_51==document.getElementsByTagName("body")[0]){
_51=null;
break;
}
_51=_51.parentNode;
}while(_51&&dojo.lang.inArray(_52,["transparent",""]));
if(_52=="transparent"){
_52=[255,255,255,0];
}else{
_52=dojo.graphics.color.extractRGB(_52);
}
return _52;
};
dojo.style.getComputedStyle=function(_53,_54,_55){
var _56=_55;
if(_53.style.getPropertyValue){
_56=_53.style.getPropertyValue(_54);
}
if(!_56){
if(document.defaultView){
var cs=document.defaultView.getComputedStyle(_53,"");
if(cs){
_56=cs.getPropertyValue(_54);
}
}else{
if(_53.currentStyle){
_56=_53.currentStyle[dojo.style.toCamelCase(_54)];
}
}
}
return _56;
};
dojo.style.getStyle=function(_58,_59){
var _5a=dojo.style.toCamelCase(_59);
var _5b=_58.style[_5a];
return (_5b?_5b:dojo.style.getComputedStyle(_58,_59,_5b));
};
dojo.style.toCamelCase=function(_5c){
var arr=_5c.split("-"),cc=arr[0];
for(var i=1;i<arr.length;i++){
cc+=arr[i].charAt(0).toUpperCase()+arr[i].substring(1);
}
return cc;
};
dojo.style.toSelectorCase=function(_5f){
return _5f.replace(/([A-Z])/g,"-$1").toLowerCase();
};
dojo.style.setOpacity=function setOpacity(_60,_61,_62){
_60=dojo.byId(_60);
var h=dojo.render.html;
if(!_62){
if(_61>=1){
if(h.ie){
dojo.style.clearOpacity(_60);
return;
}else{
_61=0.999999;
}
}else{
if(_61<0){
_61=0;
}
}
}
if(h.ie){
if(_60.nodeName.toLowerCase()=="tr"){
var tds=_60.getElementsByTagName("td");
for(var x=0;x<tds.length;x++){
tds[x].style.filter="Alpha(Opacity="+_61*100+")";
}
}
_60.style.filter="Alpha(Opacity="+_61*100+")";
}else{
if(h.moz){
_60.style.opacity=_61;
_60.style.MozOpacity=_61;
}else{
if(h.safari){
_60.style.opacity=_61;
_60.style.KhtmlOpacity=_61;
}else{
_60.style.opacity=_61;
}
}
}
};
dojo.style.getOpacity=function getOpacity(_66){
if(dojo.render.html.ie){
var _67=(_66.filters&&_66.filters.alpha&&typeof _66.filters.alpha.opacity=="number"?_66.filters.alpha.opacity:100)/100;
}else{
var _67=_66.style.opacity||_66.style.MozOpacity||_66.style.KhtmlOpacity||1;
}
return _67>=0.999999?1:Number(_67);
};
dojo.style.clearOpacity=function clearOpacity(_68){
var h=dojo.render.html;
if(h.ie){
if(_68.filters&&_68.filters.alpha){
_68.style.filter="";
}
}else{
if(h.moz){
_68.style.opacity=1;
_68.style.MozOpacity=1;
}else{
if(h.safari){
_68.style.opacity=1;
_68.style.KhtmlOpacity=1;
}else{
_68.style.opacity=1;
}
}
}
};

