dojo.provide("dojo.widget.Accordion");
dojo.require("dojo.widget.*");
dojo.require("dojo.widget.SplitPane");
dojo.require("dojo.animation.Animation");
dojo.widget.Accordion=function(){
dojo.widget.html.SplitPane.call(this);
this.widgetType="Accordion";
this._super=dojo.widget.AccordionPanel.superclass;
dojo.event.connect(this,"postCreate",this,"myPostCreate");
};
dojo.inherits(dojo.widget.Accordion,dojo.widget.html.SplitPane);
dojo.lang.extend(dojo.widget.Accordion,{sizerWidth:1,activeSizing:1,animationInterval:250,openPanel:null,myPostCreate:function(_1,_2){
for(var i=0;i<this.sizers.length;i++){
var sn=this.sizers[i];
if(sn){
sn.style.border="0px";
}
}
for(var i=0;i<this.children.length;i++){
this.children[i].setMinHeight();
if(this.children[i].open){
this.openPanel=this.children[i];
}
}
this.onResized();
},setOpenPanel:function(_5){
if(!_5){
return;
}
if(!this.openPanel){
this.openPanel=_5;
_5.open=true;
}else{
if(_5===this.openPanel){
}else{
var _6=this.openPanel;
var _7=_5;
this.openPanel.sizeShare=0;
this.openPanel.open=false;
this.openPanel.setMinHeight(true);
this.openPanel=_5;
this.openPanel.sizeShare=100;
this.openPanel.open=true;
this.onResized();
if(this.animationInterval==0){
_7.sizeShare=100;
_6.sizeShare=0;
e.animation.accordion.onResized();
}else{
var _8=new dojo.math.curves.Line([0,0],[0,100]);
var _9=new dojo.animation.Animation(_8,this.animationInterval,new dojo.math.curves.Bezier([[0],[0.05],[0.1],[0.9],[0.95],[1]]));
var _a=this;
_9.handler=function(e){
switch(e.type){
case "animate":
_7.sizeShare=parseInt(e.y);
_6.sizeShare=parseInt(100-e.y);
_a.onResized();
break;
case "end":
break;
}
};
_9.play();
}
}
}
}});
dojo.widget.tags.addParseTreeHandler("dojo:Accordion");
dojo.widget.AccordionPanel=function(){
dojo.widget.html.SplitPanePanel.call(this);
this.widgetType="AccordionPanel";
dojo.event.connect(this,"fillInTemplate",this,"myFillInTemplate");
dojo.event.connect(this,"postCreate",this,"myPostCreate");
};
dojo.inherits(dojo.widget.AccordionPanel,dojo.widget.html.SplitPanePanel);
dojo.lang.extend(dojo.widget.AccordionPanel,{sizeMin:0,initialSizeMin:null,sizeShare:0,open:false,label:"",initialContent:"",labelNode:null,scrollContent:true,initalContentNode:null,contentNode:null,templatePath:dojo.uri.dojoUri("src/widget/templates/AccordionPanel.html"),templateCssPath:dojo.uri.dojoUri("src/widget/templates/AccordionPanel.css"),setMinHeight:function(_c){
var lh=dojo.style.getContentHeight(this.labelNode);
if(!_c){
lh+=dojo.style.getContentHeight(this.initialContentNode);
this.initialSizeMin=lh;
}
this.sizeMin=lh;
},myFillInTemplate:function(_e,_f){
var sn;
if(this.label.length>0){
this.labelNode.innerHTML=this.label;
}else{
try{
sn=_f["dojo:label"][0]["dojo:label"].nodeRef;
while(sn.firstChild){
this.labelNode.firstChild.appendChild(sn.firstChild);
}
}
catch(e){
}
}
if(this.initialContent.length>0){
this.initialContentNode.innerHTML=this.initialContent;
}else{
try{
sn=_f["dojo:initialcontent"][0]["dojo:initialcontent"].nodeRef;
while(sn.firstChild){
this.initialContentNode.firstChild.appendChild(sn.firstChild);
}
}
catch(e){
}
}
sn=_f["dojo:"+this.widgetType.toLowerCase()]["nodeRef"];
while(sn.firstChild){
this.contentNode.appendChild(sn.firstChild);
}
if(this.open){
this.sizeShare=100;
}
},myPostCreate:function(){
},sizeSet:function(_11){
if(!this.scrollContent){
return;
}
if(_11<=this.sizeMin){
this.contentNode.style.display="none";
}else{
this.contentNode.style.display="block";
this.contentNode.style.overflow="auto";
var _12=(_11-((this.initialSizeMin)?this.initialSizeMin:this.sizeMin));
if(dojo.render.html.ie){
this.contentNode.style.height=_12+"px";
}else{
dojo.style.setOuterHeight(this.contentNode,_12);
}
}
},toggleOpen:function(evt){
this.parent.setOpenPanel(this);
}});
dojo.widget.tags.addParseTreeHandler("dojo:AccordionPanel");

