dojo.provide("dojo.widget.EditorTreeNode");
dojo.require("dojo.event.*");
dojo.require("dojo.dnd.*");
dojo.require("dojo.fx.html");
dojo.require("dojo.io.*");
dojo.require("dojo.widget.Container");
dojo.require("dojo.widget.Tree");
dojo.widget.tags.addParseTreeHandler("dojo:EditorTreeNode");
dojo.widget.EditorTreeNode=function(){
dojo.widget.HtmlWidget.call(this);
};
dojo.inherits(dojo.widget.EditorTreeNode,dojo.widget.HtmlWidget);
dojo.lang.extend(dojo.widget.EditorTreeNode,{widgetType:"EditorTreeNode",loadStates:{UNCHECKED:1,LOADING:2,LOADED:3},isContainer:true,domNode:null,continerNode:null,templateString:"<div class=\"dojoTreeNode\"><div dojoAttachPoint=\"containerNode\"></div></div>",childIconSrc:null,childIconFolderSrc:dojo.uri.dojoUri("src/widget/templates/images/EditorTree/closed.gif").toString(),childIconDocumentSrc:dojo.uri.dojoUri("src/widget/templates/images/EditorTree/document.gif").toString(),childIcon:null,expandIcon:null,title:"",isFolder:"",labelNode:null,titleNode:null,imgs:null,rowNode:null,tree:null,parentNode:null,depth:0,isFirstNode:false,isLastNode:false,isExpanded:false,booted:false,state:null,domNodeInitialized:false,initialize:function(_1,_2){
this.state=this.loadStates.UNCHECKED;
},adjustDepth:function(_3){
for(var i=0;i<this.children.length;i++){
this.children[i].adjustDepth(_3);
}
this.depth+=_3;
if(_3>0){
for(var i=0;i<_3;i++){
var _5=this.tree.makeBlankImg();
this.imgs.unshift(_5);
this.domNode.insertBefore(this.imgs[0],this.domNode.firstChild);
}
}
if(_3<0){
for(var i=0;i<-_3;i++){
this.imgs.shift();
this.domNode.removeChild(this.domNode.firstChild);
}
}
},markLoading:function(){
this.expandIcon.src=this.tree.expandIconSrcLoading;
},buildNode:function(_6,_7){
this.tree=_6;
this.depth=_7;
if(this.children.length){
this.isFolder=true;
}
this.imgs=[];
for(var i=0;i<this.depth+1;i++){
var _9=this.tree.makeBlankImg();
this.domNode.insertBefore(_9,this.containerNode);
this.imgs.push(_9);
}
this.expandIcon=this.imgs[this.imgs.length-1];
this.labelNode=document.createElement("span");
this.labelNode.treeNode=this.widgetId;
dojo.html.addClass(this.labelNode,"dojoTreeNodeLabel");
this.childIcon=this.tree.makeBlankImg();
this.imgs.push(this.childIcon);
this.labelNode.appendChild(this.childIcon);
this.titleNode=document.createElement("span");
var _a=document.createTextNode(this.title);
this.titleNode.appendChild(_a);
this.labelNode.appendChild(this.titleNode);
this.domNode.insertBefore(this.labelNode,this.containerNode);
dojo.html.addClass(this.titleNode,"dojoTreeNodeLabelTitle");
if(this.isFolder){
dojo.event.connect(this.expandIcon,"onclick",this,"onTreeClick");
}
dojo.event.connect(this.childIcon,"onclick",this,"onIconClick");
dojo.event.connect(this.titleNode,"onclick",this,"onTitleClick");
for(var i=0;i<this.children.length;i++){
this.children[i].isFirstNode=(i==0)?true:false;
this.children[i].isLastNode=(i==this.children.length-1)?true:false;
this.children[i].parentNode=this;
var _b=this.children[i].buildNode(this.tree,this.depth+1);
this.containerNode.appendChild(_b);
}
if(this.children.length){
this.state=this.loadStates.LOADED;
}
this.collapse();
this.domNodeInitialized=true;
dojo.event.topic.publish(this.tree.eventNames.nodeCreate,{source:this});
return this.domNode;
},onTreeClick:function(e){
dojo.event.topic.publish(this.tree.eventNames.treeClick,{source:this,event:e});
},onIconClick:function(e){
dojo.event.topic.publish(this.tree.eventNames.iconClick,{source:this,event:e});
},onTitleClick:function(e){
dojo.event.topic.publish(this.tree.eventNames.titleClick,{source:this,event:e});
},markSelected:function(){
dojo.html.addClass(this.titleNode,"dojoTreeNodeLabelSelected");
},unMarkSelected:function(){
dojo.html.removeClass(this.titleNode,"dojoTreeNodeLabelSelected");
},updateIcons:function(){
this.imgs[0].style.display=this.tree.showRootGrid?"inline":"none";
if(this.isFolder){
this.expandIcon.src=this.isExpanded?this.tree.expandIconSrcMinus:this.tree.expandIconSrcPlus;
}else{
this.expandIcon.src=this.tree.blankIconSrc;
}
this.buildChildIcon();
if(this.tree.showGrid){
if(this.depth){
this.setGridImage(-2,this.isLastNode?this.tree.gridIconSrcL:this.tree.gridIconSrcT);
}else{
if(this.isFirstNode){
this.setGridImage(-2,this.isLastNode?this.tree.gridIconSrcX:this.tree.gridIconSrcY);
}else{
this.setGridImage(-2,this.isLastNode?this.tree.gridIconSrcL:this.tree.gridIconSrcT);
}
}
}else{
this.setGridImage(-2,this.tree.blankIconSrc);
}
if((this.depth||this.tree.showRootGrid)&&this.tree.showGrid){
this.setGridImage(-1,(this.children.length&&this.isExpanded)?this.tree.gridIconSrcP:this.tree.gridIconSrcC);
}else{
if(this.tree.showGrid&&!this.tree.showRootGrid){
this.setGridImage(-1,(this.children.length&&this.isExpanded)?this.tree.gridIconSrcZ:this.tree.blankIconSrc);
}else{
this.setGridImage(-1,this.tree.blankIconSrc);
}
}
var _f=this.parentNode;
for(var i=0;i<this.depth;i++){
var idx=this.imgs.length-(3+i);
this.setGridImage(idx,(this.tree.showGrid&&!_f.isLastNode)?this.tree.gridIconSrcV:this.tree.blankIconSrc);
_f=_f.parentNode;
}
},buildChildIcon:function(){
if(this.childIconSrc=="none"){
this.childIcon.style.display="none";
return;
}
if(!this.childIconSrc){
if(this.isFolder){
this.childIconSrc=this.childIconFolderSrc;
}else{
this.childIconSrc=this.childIconDocumentSrc;
}
}
this.childIcon.style.display="inline";
this.childIcon.src=this.childIconSrc;
},setGridImage:function(idx,src){
if(idx<0){
idx=this.imgs.length+idx;
}
this.imgs[idx].style.backgroundImage="url("+src+")";
},updateIconTree:function(){
this.tree.updateIconTree.call(this);
},expand:function(){
if(this.children.length){
this.showChildren();
}
this.isExpanded=true;
this.updateIcons();
},collapse:function(){
this.hideChildren();
this.isExpanded=false;
this.updateIcons();
},hideChildren:function(){
if(this.booted){
this.tree.toggler.hide(this.containerNode);
}else{
this.containerNode.style.display="none";
}
},showChildren:function(){
if(this.booted){
this.tree.toggler.show(this.containerNode);
}else{
this.containerNode.style.display="block";
}
},startMe:function(){
this.booted=true;
for(var i=0;i<this.children.length;i++){
this.children[i].startMe();
}
},addChild:function(){
return this.tree.addChild.apply(this,arguments);
},removeChild:function(){
return this.tree.removeChild.apply(this,arguments);
},getLeftSibling:function(){
var idx=this.getParentIndex();
if(idx<=0){
return null;
}
return this.getSiblings()[idx-1];
},getSiblings:function(){
return this.parentNode.children;
},getParentIndex:function(){
return dojo.lang.indexOf(this.getSiblings(),this,true);
},getRightSibling:function(){
var idx=this.getParentIndex();
if(idx==this.getSiblings().length-1){
return null;
}
if(idx<0){
return null;
}
return this.getSiblings()[idx+1];
},edit:function(_17){
dojo.lang.mixin(this,_17);
if(_17.title){
var _18=document.createTextNode(this.title);
this.titleNode.replaceChild(_18,this.titleNode.firstChild);
}
if(_17.childIconSrc){
this.childIcon.src=this.childIconSrc;
}
}});

