dojo.provide("dojo.widget.FisheyeList");
dojo.provide("dojo.widget.html.FisheyeList");
dojo.provide("dojo.widget.html.FisheyeListItem");
dojo.require("dojo.widget.*");
dojo.require("dojo.widget.HtmlWidget");
dojo.require("dojo.widget.Container");
dojo.require("dojo.dom");
dojo.require("dojo.html");
dojo.require("dojo.style");
dojo.require("dojo.event");
dojo.widget.tags.addParseTreeHandler("dojo:FisheyeList");
dojo.widget.tags.addParseTreeHandler("dojo:FisheyeListItem");
dojo.widget.html.FisheyeList=function(){
dojo.widget.html.Container.call(this);
};
dojo.inherits(dojo.widget.html.FisheyeList,dojo.widget.html.Container);
dojo.lang.extend(dojo.widget.html.FisheyeList,{templateString:"<div class=\"dojoHtmlFisheyeListBar\"></div>",templateCssPath:dojo.uri.dojoUri("src/widget/templates/HtmlFisheyeList.css"),widgetType:"FisheyeList",EDGE:{CENTER:0,LEFT:1,RIGHT:2,TOP:3,BOTTOM:4},snarfChildDomOutput:true,pos:{x:-1,y:-1},timerScale:1,itemWidth:40,itemHeight:40,itemMaxWidth:150,itemMaxHeight:150,orientation:"horizontal",conservativeTrigger:false,effectUnits:2,itemPadding:10,attachEdge:"center",labelEdge:"bottom",enableCrappySvgSupport:false,fillInTemplate:function(_1,_2){
dojo.html.disableSelection(this.domNode);
this.isHorizontal=(this.orientation=="horizontal")?1:0;
this.selectedNode=-1;
this.isOver=false;
this.hitX1=-1;
this.hitY1=-1;
this.hitX2=-1;
this.hitY2=-1;
this.anchorEdge=this.toEdge(this.attachEdge,this.EDGE.CENTER);
this.labelEdge=this.toEdge(this.labelEdge,this.EDGE.TOP);
if(this.isHorizontal&&(this.anchorEdge==this.EDGE.LEFT)){
this.anchorEdge=this.EDGE.CENTER;
}
if(this.isHorizontal&&(this.anchorEdge==this.EDGE.RIGHT)){
this.anchorEdge=this.EDGE.CENTER;
}
if(!this.isHorizontal&&(this.anchorEdge==this.EDGE.TOP)){
this.anchorEdge=this.EDGE.CENTER;
}
if(!this.isHorizontal&&(this.anchorEdge==this.EDGE.BOTTOM)){
this.anchorEdge=this.EDGE.CENTER;
}
if(this.labelEdge==this.EDGE.CENTER){
this.labelEdge=this.EDGE.TOP;
}
if(this.isHorizontal&&(this.labelEdge==this.EDGE.LEFT)){
this.labelEdge=this.EDGE.TOP;
}
if(this.isHorizontal&&(this.labelEdge==this.EDGE.RIGHT)){
this.labelEdge=this.EDGE.TOP;
}
if(!this.isHorizontal&&(this.labelEdge==this.EDGE.TOP)){
this.labelEdge=this.EDGE.LEFT;
}
if(!this.isHorizontal&&(this.labelEdge==this.EDGE.BOTTOM)){
this.labelEdge=this.EDGE.LEFT;
}
this.proximityLeft=this.itemWidth*(this.effectUnits-0.5);
this.proximityRight=this.itemWidth*(this.effectUnits-0.5);
this.proximityTop=this.itemHeight*(this.effectUnits-0.5);
this.proximityBottom=this.itemHeight*(this.effectUnits-0.5);
if(this.anchorEdge==this.EDGE.LEFT){
this.proximityLeft=0;
}
if(this.anchorEdge==this.EDGE.RIGHT){
this.proximityRight=0;
}
if(this.anchorEdge==this.EDGE.TOP){
this.proximityTop=0;
}
if(this.anchorEdge==this.EDGE.BOTTOM){
this.proximityBottom=0;
}
if(this.anchorEdge==this.EDGE.CENTER){
this.proximityLeft/=2;
this.proximityRight/=2;
this.proximityTop/=2;
this.proximityBottom/=2;
}
},postCreate:function(_3,_4){
this.itemCount=this.children.length;
this.barWidth=(this.isHorizontal?this.itemCount:1)*this.itemWidth;
this.barHeight=(this.isHorizontal?1:this.itemCount)*this.itemHeight;
this.totalWidth=this.proximityLeft+this.proximityRight+this.barWidth;
this.totalHeight=this.proximityTop+this.proximityBottom+this.barHeight;
for(var i=0;i<this.children.length;i++){
this.children[i].posX=this.itemWidth*(this.isHorizontal?i:0);
this.children[i].posY=this.itemHeight*(this.isHorizontal?0:i);
this.children[i].cenX=this.children[i].posX+(this.itemWidth/2);
this.children[i].cenY=this.children[i].posY+(this.itemHeight/2);
var _6=this.isHorizontal?this.itemWidth:this.itemHeight;
var r=this.effectUnits*_6;
var c=this.isHorizontal?this.children[i].cenX:this.children[i].cenY;
var _9=this.isHorizontal?this.proximityLeft:this.proximityTop;
var _a=this.isHorizontal?this.proximityRight:this.proximityBottom;
var _b=this.isHorizontal?this.barWidth:this.barHeight;
var _c=r;
var _d=r;
if(_c>c+_9){
_c=c+_9;
}
if(_d>(_b-c+_a)){
_d=_b-c+_a;
}
this.children[i].effectRangeLeft=_c/_6;
this.children[i].effectRangeRght=_d/_6;
}
this.domNode.style.width=this.barWidth+"px";
this.domNode.style.height=this.barHeight+"px";
for(var i=0;i<this.children.length;i++){
var _e=this.children[i];
var _f=_e.domNode;
_f.style.left=_e.posX+"px";
_f.style.top=_e.posY+"px";
_f.style.width=this.itemWidth+"px";
_f.style.height=this.itemHeight+"px";
if(_e.svgNode){
_e.svgNode.style.position="absolute";
_e.svgNode.style.left=this.itemPadding+"%";
_e.svgNode.style.top=this.itemPadding+"%";
_e.svgNode.style.width=(100-2*this.itemPadding)+"%";
_e.svgNode.style.height=(100-2*this.itemPadding)+"%";
_e.svgNode.style.zIndex=1;
_e.svgNode.setSize(this.itemWidth,this.itemHeight);
}else{
_e.imgNode.style.left=this.itemPadding+"%";
_e.imgNode.style.top=this.itemPadding+"%";
_e.imgNode.style.width=(100-2*this.itemPadding)+"%";
_e.imgNode.style.height=(100-2*this.itemPadding)+"%";
}
}
this.calcHitGrid();
if(!this.conservativeTrigger){
dojo.event.connect(document.documentElement,"onmousemove",this,"mouseHandler");
}
dojo.event.connect(document.documentElement,"onmouseout",this,"onBodyOut");
},onBodyOut:function(e){
if(dojo.html.overElement(dojo.html.body(),e)){
return;
}
this.setDormant(e);
},setDormant:function(e){
if(!this.isOver){
return;
}
this.isOver=false;
if(this.conservativeTrigger){
dojo.event.disconnect(document.documentElement,"onmousemove",this,"mouseHandler");
}
this.onGridMouseMove(-1,-1);
},setActive:function(e){
if(this.isOver){
return;
}
this.isOver=true;
if(this.conservativeTrigger){
dojo.event.connect(document.documentElement,"onmousemove",this,"mouseHandler");
this.timerScale=0;
this.mouseHandler(e);
this.expandSlowly();
}
},mouseHandler:function(e){
var p=this.getCursorPos(e);
if((p.x>=this.hitX1)&&(p.x<=this.hitX2)&&(p.y>=this.hitY1)&&(p.y<=this.hitY2)){
if(!this.isOver){
this.setActive(e);
}
this.onGridMouseMove(p.x-this.hitX1,p.y-this.hitY1);
}else{
if(this.isOver){
this.setDormant(e);
}
}
},onResized:function(){
this.calcHitGrid();
},onGridMouseMove:function(x,y){
this.pos={x:x,y:y};
this.paint();
},paint:function(){
var x=this.pos.x;
var y=this.pos.y;
if(this.itemCount<=0){
return;
}
var pos=this.isHorizontal?x:y;
var prx=this.isHorizontal?this.proximityLeft:this.proximityTop;
var siz=this.isHorizontal?this.itemWidth:this.itemHeight;
var sim=this.isHorizontal?(1-this.timerScale)*this.itemWidth+this.timerScale*this.itemMaxWidth:(1-this.timerScale)*this.itemHeight+this.timerScale*this.itemMaxHeight;
var cen=((pos-prx)/siz)-0.5;
var _1e=(sim/siz)-0.5;
if(_1e>this.effectUnits){
_1e=this.effectUnits;
}
var _1f=0;
if(this.anchorEdge==this.EDGE.BOTTOM){
var _20=(y-this.proximityTop)/this.itemHeight;
_1f=(_20>0.5)?1:y/(this.proximityTop+(this.itemHeight/2));
}
if(this.anchorEdge==this.EDGE.TOP){
var _20=(y-this.proximityTop)/this.itemHeight;
_1f=(_20<0.5)?1:(this.totalHeight-y)/(this.proximityBottom+(this.itemHeight/2));
}
if(this.anchorEdge==this.EDGE.RIGHT){
var _20=(x-this.proximityLeft)/this.itemWidth;
_1f=(_20>0.5)?1:x/(this.proximityLeft+(this.itemWidth/2));
}
if(this.anchorEdge==this.EDGE.LEFT){
var _20=(x-this.proximityLeft)/this.itemWidth;
_1f=(_20<0.5)?1:(this.totalWidth-x)/(this.proximityRight+(this.itemWidth/2));
}
if(this.anchorEdge==this.EDGE.CENTER){
if(this.isHorizontal){
_1f=y/(this.totalHeight);
}else{
_1f=x/(this.totalWidth);
}
if(_1f>0.5){
_1f=1-_1f;
}
_1f*=2;
}
for(var i=0;i<this.itemCount;i++){
var _22=this.weightAt(cen,i);
if(_22<0){
_22=0;
}
this.setitemsize(i,_22*_1f);
}
var _23=Math.round(cen);
var _24=0;
if(cen<0){
_23=0;
}else{
if(cen>this.itemCount-1){
_23=this.itemCount-1;
}else{
_24=(cen-_23)*((this.isHorizontal?this.itemWidth:this.itemHeight)-this.children[_23].sizeMain);
}
}
this.positionElementsFrom(_23,_24);
},weightAt:function(cen,i){
var _27=Math.abs(cen-i);
var _28=((cen-i)>0)?this.children[i].effectRangeRght:this.children[i].effectRangeLeft;
return (_27>_28)?0:(1-_27/_28);
},positionFromNode:function(p,w){
this.setitemsize(p,w);
var wx=w;
for(var i=p;i<this.itemCount;i++){
wx=0.8*wx;
this.setitemsize(i,wx);
}
var wx=w;
for(var i=p;i>=0;i--){
wx=0.8*wx;
this.setitemsize(i,wx);
}
},setitemsize:function(p,_2e){
_2e*=this.timerScale;
var w=Math.round(this.itemWidth+((this.itemMaxWidth-this.itemWidth)*_2e));
var h=Math.round(this.itemHeight+((this.itemMaxHeight-this.itemHeight)*_2e));
if(this.isHorizontal){
this.children[p].sizeW=w;
this.children[p].sizeH=h;
this.children[p].sizeMain=w;
this.children[p].sizeOff=h;
var y=0;
if(this.anchorEdge==this.EDGE.TOP){
y=(this.children[p].cenY-(this.itemHeight/2));
}else{
if(this.anchorEdge==this.EDGE.BOTTOM){
y=(this.children[p].cenY-(h-(this.itemHeight/2)));
}else{
y=(this.children[p].cenY-(h/2));
}
}
this.children[p].usualX=Math.round(this.children[p].cenX-(w/2));
this.children[p].domNode.style.top=y+"px";
this.children[p].domNode.style.left=this.children[p].usualX+"px";
}else{
this.children[p].sizeW=w;
this.children[p].sizeH=h;
this.children[p].sizeOff=w;
this.children[p].sizeMain=h;
var x=0;
if(this.anchorEdge==this.EDGE.LEFT){
x=this.children[p].cenX-(this.itemWidth/2);
}else{
if(this.anchorEdge==this.EDGE.RIGHT){
x=this.children[p].cenX-(w-(this.itemWidth/2));
}else{
x=this.children[p].cenX-(w/2);
}
}
this.children[p].domNode.style.left=x+"px";
this.children[p].usualY=Math.round(this.children[p].cenY-(h/2));
this.children[p].domNode.style.top=this.children[p].usualY+"px";
}
this.children[p].domNode.style.width=w+"px";
this.children[p].domNode.style.height=h+"px";
if(this.children[p].svgNode){
this.children[p].svgNode.setSize(w,h);
}
},positionElementsFrom:function(p,_34){
var pos=0;
if(this.isHorizontal){
pos=Math.round(this.children[p].usualX+_34);
this.children[p].domNode.style.left=pos+"px";
}else{
pos=Math.round(this.children[p].usualY+_34);
this.children[p].domNode.style.top=pos+"px";
}
this.positionLabel(this.children[p]);
var _36=pos;
for(var i=p-1;i>=0;i--){
_36-=this.children[i].sizeMain;
if(this.isHorizontal){
this.children[i].domNode.style.left=_36+"px";
}else{
this.children[i].domNode.style.top=_36+"px";
}
this.positionLabel(this.children[i]);
}
var _38=pos;
for(var i=p+1;i<this.itemCount;i++){
_38+=this.children[i-1].sizeMain;
if(this.isHorizontal){
this.children[i].domNode.style.left=_38+"px";
}else{
this.children[i].domNode.style.top=_38+"px";
}
this.positionLabel(this.children[i]);
}
},positionLabel:function(itm){
var x=0;
var y=0;
var _3c=dojo.style.getOuterWidth(itm.lblNode);
var _3d=dojo.style.getOuterHeight(itm.lblNode);
if(this.labelEdge==this.EDGE.TOP){
x=Math.round((itm.sizeW/2)-(_3c/2));
y=-_3d;
}
if(this.labelEdge==this.EDGE.BOTTOM){
x=Math.round((itm.sizeW/2)-(_3c/2));
y=itm.sizeH;
}
if(this.labelEdge==this.EDGE.LEFT){
x=-_3c;
y=Math.round((itm.sizeH/2)-(_3d/2));
}
if(this.labelEdge==this.EDGE.RIGHT){
x=itm.sizeW;
y=Math.round((itm.sizeH/2)-(_3d/2));
}
itm.lblNode.style.left=x+"px";
itm.lblNode.style.top=y+"px";
},getCursorPos:function(e){
return {"x":e.pageX||e.clientX+dojo.html.body().scrollLeft,"y":e.pageY||e.clientY+dojo.html.body().scrollTop};
},calcHitGrid:function(){
var pos=dojo.style.getAbsolutePosition(this.domNode);
this.hitX1=pos.x-this.proximityLeft;
this.hitY1=pos.y-this.proximityTop;
this.hitX2=this.hitX1+this.totalWidth;
this.hitY2=this.hitY1+this.totalHeight;
},toEdge:function(inp,def){
return this.EDGE[inp.toUpperCase()]||def;
},expandSlowly:function(){
if(!this.isOver){
return;
}
this.timerScale+=0.2;
this.paint();
if(this.timerScale<1){
dojo.lang.setTimeout(this,"expandSlowly",10);
}
}});
dojo.widget.html.FisheyeListItem=function(){
dojo.widget.HtmlWidget.call(this);
};
dojo.inherits(dojo.widget.html.FisheyeListItem,dojo.widget.HtmlWidget);
dojo.lang.extend(dojo.widget.html.FisheyeListItem,{widgetType:"FisheyeListItem",iconSrc:"",svgSrc:"",caption:"",blankImgPath:dojo.uri.dojoUri("src/widget/templates/images/blank.gif"),templateString:"<div class=\"dojoHtmlFisheyeListItem\">"+"  <img class=\"dojoHtmlFisheyeListItemImage\" dojoAttachPoint=\"imgNode\" dojoAttachEvent=\"onMouseOver;onMouseOut;onClick\">"+"  <div class=\"dojoHtmlFisheyeListItemLabel\" dojoAttachPoint=\"lblNode\"></div>"+"</div>",imgNode:null,fillInTemplate:function(){
if(this.svgSrc!=""){
this.svgNode=this.createSvgNode(this.svgSrc);
this.domNode.appendChild(this.svgNode);
this.imgNode.style.display="none";
}else{
if((this.iconSrc.toLowerCase().substring(this.iconSrc.length-4)==".png")&&(dojo.render.html.ie)){
this.imgNode.style.filter="progid:DXImageTransform.Microsoft.AlphaImageLoader(src='"+this.iconSrc+"', sizingMethod='scale')";
this.imgNode.src=this.blankImgPath.toString();
}else{
this.imgNode.src=this.iconSrc;
}
}
if(this.lblNode){
this.lblNode.appendChild(document.createTextNode(this.caption));
}
dojo.html.disableSelection(this.domNode);
},createSvgNode:function(src){
var elm=document.createElement("embed");
elm.src=src;
elm.type="image/svg+xml";
elm.style.width="1px";
elm.style.height="1px";
elm.loaded=0;
elm.setSizeOnLoad=false;
elm.onload=function(){
this.svgRoot=this.getSVGDocument().rootElement;
this.svgDoc=this.getSVGDocument().documentElement;
this.zeroWidth=this.svgRoot.width.baseVal.value;
this.zeroHeight=this.svgRoot.height.baseVal.value;
this.loaded=true;
if(this.setSizeOnLoad){
this.setSize(this.setWidth,this.setHeight);
}
};
elm.setSize=function(w,h){
if(!this.loaded){
this.setWidth=w;
this.setHeight=h;
this.setSizeOnLoad=true;
return;
}
this.style.width=w+"px";
this.style.height=h+"px";
this.svgRoot.width.baseVal.value=w;
this.svgRoot.height.baseVal.value=h;
var _46=w/this.zeroWidth;
var _47=h/this.zeroHeight;
for(var i=0;i<this.svgDoc.childNodes.length;i++){
if(this.svgDoc.childNodes[i].setAttribute){
this.svgDoc.childNodes[i].setAttribute("transform","scale("+_46+","+_47+")");
}
}
};
return elm;
},onMouseOver:function(e){
if(!this.parent.isOver){
this.parent.setActive(e);
}
if(this.caption!=""){
dojo.html.addClass(this.lblNode,"selected");
this.parent.positionLabel(this);
}
},onMouseOut:function(){
dojo.html.removeClass(this.lblNode,"selected");
},onClick:function(){
}});

