dojo.provide("dojo.widget.Parse");
dojo.require("dojo.widget.Manager");
dojo.require("dojo.string");
dojo.require("dojo.dom");
dojo.widget.Parse=function(_1){
this.propertySetsList=[];
this.fragment=_1;
this.createComponents=function(_2,_3){
var _4=dojo.widget.tags;
var _5=[];
for(var _6 in _2){
var _7=false;
try{
if(_2[_6]&&(_2[_6]["tagName"])&&(_2[_6]!=_2["nodeRef"])){
var tn=new String(_2[_6]["tagName"]);
var _9=tn.split(";");
for(var x=0;x<_9.length;x++){
var _b=dojo.string.trim(_9[x]).toLowerCase();
if(_4[_b]){
_7=true;
_2[_6].tagName=_b;
var _c=_4[_b](_2[_6],this,_3,_2[_6]["index"]);
_5.push(_c);
}else{
if((dojo.lang.isString(_b))&&(_b.substr(0,5)=="dojo:")){
dojo.debug("no tag handler registed for type: ",_b);
}
}
}
}
}
catch(e){
dojo.debug("fragment creation error:",e);
}
if((!_7)&&(typeof _2[_6]=="object")&&(_2[_6]!=_2.nodeRef)&&(_2[_6]!=_2["tagName"])){
_5.push(this.createComponents(_2[_6],_3));
}
}
return _5;
};
this.parsePropertySets=function(_d){
return [];
var _e=[];
for(var _f in _d){
if((_d[_f]["tagName"]=="dojo:propertyset")){
_e.push(_d[_f]);
}
}
this.propertySetsList.push(_e);
return _e;
};
this.parseProperties=function(_10){
var _11={};
for(var _12 in _10){
if((_10[_12]==_10["tagName"])||(_10[_12]==_10.nodeRef)){
}else{
if((_10[_12]["tagName"])&&(dojo.widget.tags[_10[_12].tagName.toLowerCase()])){
}else{
if((_10[_12][0])&&(_10[_12][0].value!="")){
try{
if(_12.toLowerCase()=="dataprovider"){
var _13=this;
this.getDataProvider(_13,_10[_12][0].value);
_11.dataProvider=this.dataProvider;
}
_11[_12]=_10[_12][0].value;
var _14=this.parseProperties(_10[_12]);
for(var _15 in _14){
_11[_15]=_14[_15];
}
}
catch(e){
dojo.debug(e);
}
}
}
}
}
return _11;
};
this.getDataProvider=function(_16,_17){
dojo.io.bind({url:_17,load:function(_18,_19){
if(_18=="load"){
_16.dataProvider=_19;
}
},mimetype:"text/javascript",sync:true});
};
this.getPropertySetById=function(_1a){
for(var x=0;x<this.propertySetsList.length;x++){
if(_1a==this.propertySetsList[x]["id"][0].value){
return this.propertySetsList[x];
}
}
return "";
};
this.getPropertySetsByType=function(_1c){
var _1d=[];
for(var x=0;x<this.propertySetsList.length;x++){
var cpl=this.propertySetsList[x];
var _20=cpl["componentClass"]||cpl["componentType"]||null;
if((_20)&&(propertySetId==_20[0].value)){
_1d.push(cpl);
}
}
return _1d;
};
this.getPropertySets=function(_21){
var ppl="dojo:propertyproviderlist";
var _23=[];
var _24=_21["tagName"];
if(_21[ppl]){
var _25=_21[ppl].value.split(" ");
for(propertySetId in _25){
if((propertySetId.indexOf("..")==-1)&&(propertySetId.indexOf("://")==-1)){
var _26=this.getPropertySetById(propertySetId);
if(_26!=""){
_23.push(_26);
}
}else{
}
}
}
return (this.getPropertySetsByType(_24)).concat(_23);
};
this.createComponentFromScript=function(_27,_28,_29){
var ltn="dojo:"+_28.toLowerCase();
if(dojo.widget.tags[ltn]){
_29.fastMixIn=true;
return [dojo.widget.tags[ltn](_29,this,null,null,_29)];
}else{
if(ltn.substr(0,5)=="dojo:"){
dojo.debug("no tag handler registed for type: ",ltn);
}
}
};
};
dojo.widget._parser_collection={"dojo":new dojo.widget.Parse()};
dojo.widget.getParser=function(_2b){
if(!_2b){
_2b="dojo";
}
if(!this._parser_collection[_2b]){
this._parser_collection[_2b]=new dojo.widget.Parse();
}
return this._parser_collection[_2b];
};
dojo.widget.createWidget=function(_2c,_2d,_2e,_2f){
function fromScript(_30,_31,_32){
var _33=_31.toLowerCase();
var _34="dojo:"+_33;
_32[_34]={dojotype:[{value:_33}],nodeRef:_30,fastMixIn:true};
return dojo.widget.getParser().createComponentFromScript(_30,_31,_32,true);
}
if(typeof _2c!="string"&&typeof _2d=="string"){
dojo.deprecated("dojo.widget.createWidget","argument order is now of the form "+"dojo.widget.createWidget(NAME, [PROPERTIES, [REFERENCENODE, [POSITION]]])");
return fromScript(_2c,_2d,_2e);
}
_2d=_2d||{};
var _35=false;
var tn=null;
var h=dojo.render.html.capable;
if(h){
tn=document.createElement("span");
}
if(!_2e){
_35=true;
_2e=tn;
if(h){
dojo.html.body().appendChild(_2e);
}
}else{
if(_2f){
dojo.dom.insertAtPosition(tn,_2e,_2f);
}else{
tn=_2e;
}
}
var _38=fromScript(tn,_2c,_2d);
if(!_38[0]||typeof _38[0].widgetType=="undefined"){
throw new Error("createWidget: Creation of \""+_2c+"\" widget failed.");
}
if(_35){
if(_38[0].domNode.parentNode){
_38[0].domNode.parentNode.removeChild(_38[0].domNode);
}
}
return _38[0];
};
dojo.widget.fromScript=function(_39,_3a,_3b,_3c){
dojo.deprecated("dojo.widget.fromScript"," use "+"dojo.widget.createWidget instead");
return dojo.widget.createWidget(_39,_3a,_3b,_3c);
};

