dojo.provide("dojo.widget.SplitPane");
dojo.provide("dojo.widget.SplitPanePanel");
dojo.provide("dojo.widget.html.SplitPane");
dojo.provide("dojo.widget.html.SplitPanePanel");
dojo.require("dojo.widget.*");
dojo.require("dojo.widget.LayoutPane");
dojo.require("dojo.widget.Container");
dojo.require("dojo.html");
dojo.require("dojo.style");
dojo.require("dojo.dom");
dojo.widget.html.SplitPane=function(){
dojo.widget.html.Container.call(this);
this.sizers=[];
};
dojo.inherits(dojo.widget.html.SplitPane,dojo.widget.html.Container);
dojo.lang.extend(dojo.widget.html.SplitPane,{widgetType:"SplitPane",virtualSizer:null,isHorizontal:0,paneBefore:null,paneAfter:null,isSizing:false,dragOffset:null,startPoint:null,lastPoint:null,sizingSplitter:null,isActiveResize:0,offsetX:0,offsetY:0,isDraggingLeft:0,templateCssPath:dojo.uri.dojoUri("src/widget/templates/HtmlSplitPane.css"),originPos:null,activeSizing:"",sizerWidth:15,orientation:"horizontal",debugName:"",fillInTemplate:function(){
dojo.style.insertCssFile(this.templateCssPath,null,true);
dojo.html.addClass(this.domNode,"dojoHtmlSplitPane");
this.domNode.style.overflow="hidden";
this.paneWidth=dojo.style.getContentWidth(this.domNode);
this.paneHeight=dojo.style.getContentHeight(this.domNode);
this.isHorizontal=(this.orientation=="horizontal")?1:0;
this.isActiveResize=(this.activeSizing=="1")?1:0;
},onResized:function(e){
this.paneWidth=dojo.style.getContentWidth(this.domNode);
this.paneHeight=dojo.style.getContentHeight(this.domNode);
this.layoutPanels();
this.notifyChildrenOfResize();
},postCreate:function(_2,_3,_4){
for(var i=0;i<this.children.length;i++){
with(this.children[i].domNode.style){
position="absolute";
}
dojo.html.addClass(this.children[i].domNode,"dojoHtmlSplitterPanePanel");
}
for(var i=0;i<this.children.length-1;i++){
var _6=this;
var _7=(function(){
var _8=i;
return function(e){
_6.beginSizing(e,_8);
};
})();
this.sizers[i]=document.createElement("div");
this.sizers[i].style.position="absolute";
this.sizers[i].onmousedown=_7;
this.sizers[i].className=this.isHorizontal?"dojoHtmlSplitPaneSizerH":"dojoHtmlSplitPaneSizerV";
this.domNode.appendChild(this.sizers[i]);
dojo.html.disableSelection(this.sizers[i]);
}
this.virtualSizer=document.createElement("div");
this.virtualSizer.style.position="absolute";
this.virtualSizer.style.display="none";
this.virtualSizer.style.zIndex=10;
this.virtualSizer.className=this.isHorizontal?"dojoHtmlSplitPaneVirtualSizerH":"dojoHtmlSplitPaneVirtualSizerV";
this.domNode.appendChild(this.virtualSizer);
dojo.html.disableSelection(this.virtualSizer);
this.resizeSoon();
},layoutPanels:function(){
var _a=this.isHorizontal?this.paneWidth:this.paneHeight;
if(this.children.length>1){
_a-=this.sizerWidth*(this.children.length-1);
}
var _b=0;
for(var i=0;i<this.children.length;i++){
_b+=this.children[i].sizeShare;
}
var _d=_a/_b;
var _e=0;
for(var i=0;i<this.children.length-1;i++){
var _f=Math.round(_d*this.children[i].sizeShare);
this.children[i].sizeActual=_f;
_e+=_f;
}
this.children[this.children.length-1].sizeActual=_a-_e;
this.checkSizes();
var pos=0;
var _f=this.children[0].sizeActual;
this.movePanel(this.children[0].domNode,pos,_f);
this.children[0].position=pos;
pos+=_f;
for(var i=1;i<this.children.length;i++){
this.movePanel(this.sizers[i-1],pos,this.sizerWidth);
this.sizers[i-1].position=pos;
pos+=this.sizerWidth;
_f=this.children[i].sizeActual;
this.movePanel(this.children[i].domNode,pos,_f);
this.children[i].position=pos;
pos+=_f;
}
for(var i=0;i<this.children.length;i++){
this.children[i].onResized();
}
},movePanel:function(_11,pos,_13){
if(this.isHorizontal){
_11.style.left=pos+"px";
_11.style.top=0;
dojo.style.setOuterWidth(_11,_13);
dojo.style.setOuterHeight(_11,this.paneHeight);
}else{
_11.style.left=0;
_11.style.top=pos+"px";
dojo.style.setOuterWidth(_11,this.paneWidth);
dojo.style.setOuterHeight(_11,_13);
}
},growPane:function(_14,_15){
if(_14>0){
if(_15.sizeActual>_15.sizeMin){
if((_15.sizeActual-_15.sizeMin)>_14){
_15.sizeActual=_15.sizeActual-_14;
_14=0;
}else{
_14-=_15.sizeActual-_15.sizeMin;
_15.sizeActual=_15.sizeMin;
}
}
}
return _14;
},checkSizes:function(){
var _16=0;
var _17=0;
for(var i=0;i<this.children.length;i++){
_17+=this.children[i].sizeActual;
_16+=this.children[i].sizeMin;
}
if(_16<=_17){
var _19=0;
for(var i=0;i<this.children.length;i++){
if(this.children[i].sizeActual<this.children[i].sizeMin){
_19+=this.children[i].sizeMin-this.children[i].sizeActual;
this.children[i].sizeActual=this.children[i].sizeMin;
}
}
if(_19>0){
if(this.isDraggingLeft){
for(var i=this.children.length-1;i>=0;i--){
_19=this.growPane(_19,this.children[i]);
}
}else{
for(var i=0;i<this.children.length;i++){
_19=this.growPane(_19,this.children[i]);
}
}
}
}else{
for(var i=0;i<this.children.length;i++){
this.children[i].sizeActual=Math.round(_17*(this.children[i].sizeMin/_16));
}
}
},beginSizing:function(e,i){
var _1c=window.event?window.event.offsetX:e.layerX;
var _1d=window.event?window.event.offsetY:e.layerY;
var _1e=window.event?window.event.clientX:e.pageX;
var _1f=window.event?window.event.clientY:e.pageY;
this.paneBefore=this.children[i];
this.paneAfter=this.children[i+1];
this.isSizing=true;
this.sizingSplitter=this.sizers[i];
this.originPos=dojo.style.getAbsolutePosition(this.domNode,true);
this.dragOffset={"x":_1c,"y":_1d};
this.startPoint={"x":_1e,"y":_1f};
this.lastPoint={"x":_1e,"y":_1f};
this.offsetX=_1e-_1c;
this.offsetY=_1f-_1d;
if(!this.isActiveResize){
this.showSizingLine();
}
dojo.event.connect(document.documentElement,"onmousemove",this,"changeSizing");
dojo.event.connect(document.documentElement,"onmouseup",this,"endSizing");
},changeSizing:function(e){
var _21=window.event?window.event.clientX:e.pageX;
var _22=window.event?window.event.clientY:e.pageY;
if(this.isActiveResize){
this.lastPoint={"x":_21,"y":_22};
this.movePoint();
this.updateSize();
}else{
this.lastPoint={"x":_21,"y":_22};
this.movePoint();
this.moveSizingLine();
}
},endSizing:function(e){
if(!this.isActiveResize){
this.hideSizingLine();
}
this.updateSize();
this.isSizing=false;
dojo.event.disconnect(document.documentElement,"onmousemove",this,"changeSizing");
dojo.event.disconnect(document.documentElement,"onmouseup",this,"endSizing");
},movePoint:function(){
p=this.screenToMainClient(this.lastPoint);
if(this.isHorizontal){
var a=p.x-this.dragOffset.x;
a=this.legaliseSplitPoint(a);
p.x=a+this.dragOffset.x;
}else{
var a=p.y-this.dragOffset.y;
a=this.legaliseSplitPoint(a);
p.y=a+this.dragOffset.y;
}
this.lastPoint=this.mainClientToScreen(p);
},screenToClient:function(pt){
pt.x-=(this.offsetX+this.sizingSplitter.position);
pt.y-=(this.offsetY+this.sizingSplitter.position);
return pt;
},clientToScreen:function(pt){
pt.x+=(this.offsetX+this.sizingSplitter.position);
pt.y+=(this.offsetY+this.sizingSplitter.position);
return pt;
},screenToMainClient:function(pt){
pt.x-=this.offsetX;
pt.y-=this.offsetY;
return pt;
},mainClientToScreen:function(pt){
pt.x+=this.offsetX;
pt.y+=this.offsetY;
return pt;
},legaliseSplitPoint:function(a){
a+=this.sizingSplitter.position;
this.isDraggingLeft=(a>0)?1:0;
if(!this.isActiveResize){
if(a<this.paneBefore.position+this.paneBefore.sizeMin){
a=this.paneBefore.position+this.paneBefore.sizeMin;
}
if(a>this.paneAfter.position+(this.paneAfter.sizeActual-(this.sizerWidth+this.paneAfter.sizeMin))){
a=this.paneAfter.position+(this.paneAfter.sizeActual-(this.sizerWidth+this.paneAfter.sizeMin));
}
}
a-=this.sizingSplitter.position;
this.checkSizes();
return a;
},updateSize:function(){
var p=this.clientToScreen(this.lastPoint);
var p=this.screenToClient(this.lastPoint);
var pos=this.isHorizontal?p.x-(this.dragOffset.x+this.originPos.x):p.y-(this.dragOffset.y+this.originPos.y);
var _2c=this.paneBefore.position;
var _2d=this.paneAfter.position+this.paneAfter.sizeActual;
this.paneBefore.sizeActual=pos-_2c;
this.paneAfter.position=pos+this.sizerWidth;
this.paneAfter.sizeActual=_2d-this.paneAfter.position;
for(var i=0;i<this.children.length;i++){
this.children[i].sizeShare=this.children[i].sizeActual;
}
this.layoutPanels();
},showSizingLine:function(){
this.moveSizingLine();
if(this.isHorizontal){
dojo.style.setOuterWidth(this.virtualSizer,this.sizerWidth);
dojo.style.setOuterHeight(this.virtualSizer,this.paneHeight);
}else{
dojo.style.setOuterWidth(this.virtualSizer,this.paneWidth);
dojo.style.setOuterHeight(this.virtualSizer,this.sizerWidth);
}
this.virtualSizer.style.display="block";
},hideSizingLine:function(){
this.virtualSizer.style.display="none";
},moveSizingLine:function(){
var _2f={"x":0,"y":0};
if(this.isHorizontal){
_2f.x+=(this.lastPoint.x-this.startPoint.x)+this.sizingSplitter.position;
}else{
_2f.y+=(this.lastPoint.y-this.startPoint.y)+this.sizingSplitter.position;
}
this.virtualSizer.style.left=_2f.x+"px";
this.virtualSizer.style.top=_2f.y+"px";
}});
dojo.lang.extend(dojo.widget.Widget,{sizeMin:10,sizeShare:10});
dojo.widget.html.SplitPanePanel=function(){
dojo.widget.html.LayoutPane.call(this);
};
dojo.inherits(dojo.widget.html.SplitPanePanel,dojo.widget.html.LayoutPane);
dojo.lang.extend(dojo.widget.html.SplitPanePanel,{widgetType:"SplitPanePanel"});
dojo.widget.tags.addParseTreeHandler("dojo:SplitPane");
dojo.widget.tags.addParseTreeHandler("dojo:SplitPanePanel");

