dojo.provide("dojo.widget.html.DatePicker");
dojo.require("dojo.widget.*");
dojo.require("dojo.widget.HtmlWidget");
dojo.require("dojo.widget.DatePicker");
dojo.require("dojo.event.*");
dojo.require("dojo.html");
dojo.widget.html.DatePicker=function(){
dojo.widget.DatePicker.call(this);
dojo.widget.HtmlWidget.call(this);
var _1=this;
this.today="";
this.date="";
this.storedDate="";
this.currentDate={};
this.firstSaturday={};
this.classNames={previous:"previousMonth",current:"currentMonth",next:"nextMonth",currentDate:"currentDate",selectedDate:"selectedItem"};
this.templatePath=dojo.uri.dojoUri("src/widget/templates/HtmlDatePicker.html");
this.templateCssPath=dojo.uri.dojoUri("src/widget/templates/HtmlDatePicker.css");
this.fillInTemplate=function(){
this.initData();
this.initUI();
};
this.initData=function(){
this.today=new Date();
if(this.storedDate&&(this.storedDate.split("-").length>2)){
this.date=dojo.widget.DatePicker.util.fromRfcDate(this.storedDate);
}else{
this.date=this.today;
}
this.today.setHours(0);
this.date.setHours(0);
var _2=this.date.getMonth();
var _3=dojo.widget.DatePicker.util.initFirstSaturday(this.date.getMonth().toString(),this.date.getFullYear());
this.firstSaturday.year=_3.year;
this.firstSaturday.month=_3.month;
this.firstSaturday.date=_3.date;
};
this.setDate=function(_4){
this.storedDate=_4;
};
this.initUI=function(){
this.selectedIsUsed=false;
this.currentIsUsed=false;
var _5="";
var _6=new Date();
var _7=this.calendarDatesContainerNode.getElementsByTagName("td");
var _8;
_6.setHours(8);
var _9=new Date(this.firstSaturday.year,this.firstSaturday.month,this.firstSaturday.date,8);
if(this.firstSaturday.date<7){
var _a=6;
for(var i=this.firstSaturday.date;i>0;i--){
_8=_7.item(_a);
_8.innerHTML=_9.getDate();
dojo.html.setClass(_8,this.getDateClassName(_9,"current"));
_a--;
_6=_9;
_9=this.incrementDate(_9,false);
}
for(var i=_a;i>-1;i--){
_8=_7.item(i);
_8.innerHTML=_9.getDate();
dojo.html.setClass(_8,this.getDateClassName(_9,"previous"));
_6=_9;
_9=this.incrementDate(_9,false);
}
}else{
_9.setDate(1);
for(var i=0;i<7;i++){
_8=_7.item(i);
_8.innerHTML=i+1;
dojo.html.setClass(_8,this.getDateClassName(_9,"current"));
_6=_9;
_9=this.incrementDate(_9,true);
}
}
_6.setDate(this.firstSaturday.date);
_6.setMonth(this.firstSaturday.month);
_6.setFullYear(this.firstSaturday.year);
_9=this.incrementDate(_6,true);
var _c=7;
_8=_7.item(_c);
while((_9.getMonth()==_6.getMonth())&&(_c<42)){
_8.innerHTML=_9.getDate();
dojo.html.setClass(_8,this.getDateClassName(_9,"current"));
_8=_7.item(++_c);
_6=_9;
_9=this.incrementDate(_9,true);
}
while(_c<42){
_8.innerHTML=_9.getDate();
dojo.html.setClass(_8,this.getDateClassName(_9,"next"));
_8=_7.item(++_c);
_6=_9;
_9=this.incrementDate(_9,true);
}
this.setMonthLabel(this.firstSaturday.month);
this.setYearLabels(this.firstSaturday.year);
};
this.incrementDate=function(_d,_e){
var _f=_d.getTime();
var _10=1000*60*60*24;
_f=(_e)?(_f+_10):(_f-_10);
var _11=new Date();
_11.setTime(_f);
return _11;
};
this.incrementWeek=function(_12,_13){
dojo.unimplemented("dojo.widget.html.DatePicker.incrementWeek");
};
this.incrementMonth=function(_14,_15){
dojo.unimplemented("dojo.widget.html.DatePicker.incrementMonth");
};
this.incrementYear=function(_16,_17){
dojo.unimplemented("dojo.widget.html.DatePicker.incrementYear");
};
this.onIncrementDate=function(evt){
dojo.unimplemented("dojo.widget.html.DatePicker.onIncrementDate");
};
this.onIncrementWeek=function(evt){
evt.stopPropagation();
dojo.unimplemented("dojo.widget.html.DatePicker.onIncrementWeek");
switch(evt.target){
case this.increaseWeekNode:
break;
case this.decreaseWeekNode:
break;
}
};
this.onIncrementMonth=function(evt){
evt.stopPropagation();
var _1b=this.firstSaturday.month;
var _1c=this.firstSaturday.year;
switch(evt.currentTarget){
case this.increaseMonthNode:
if(_1b<11){
_1b++;
}else{
_1b=0;
_1c++;
this.setYearLabels(_1c);
}
break;
case this.decreaseMonthNode:
if(_1b>0){
_1b--;
}else{
_1b=11;
_1c--;
this.setYearLabels(_1c);
}
break;
case this.increaseMonthNode.getElementsByTagName("img").item(0):
if(_1b<11){
_1b++;
}else{
_1b=0;
_1c++;
this.setYearLabels(_1c);
}
break;
case this.decreaseMonthNode.getElementsByTagName("img").item(0):
if(_1b>0){
_1b--;
}else{
_1b=11;
_1c--;
this.setYearLabels(_1c);
}
break;
}
var _1d=dojo.widget.DatePicker.util.initFirstSaturday(_1b.toString(),_1c);
this.firstSaturday.year=_1d.year;
this.firstSaturday.month=_1d.month;
this.firstSaturday.date=_1d.date;
this.initUI();
};
this.onIncrementYear=function(evt){
evt.stopPropagation();
var _1f=this.firstSaturday.year;
switch(evt.target){
case this.nextYearLabelNode:
_1f++;
break;
case this.previousYearLabelNode:
_1f--;
break;
}
var _20=dojo.widget.DatePicker.util.initFirstSaturday(this.firstSaturday.month.toString(),_1f);
this.firstSaturday.year=_20.year;
this.firstSaturday.month=_20.month;
this.firstSaturday.date=_20.date;
this.initUI();
};
this.setMonthLabel=function(_21){
this.monthLabelNode.innerHTML=this.months[_21];
};
this.setYearLabels=function(_22){
this.previousYearLabelNode.innerHTML=_22-1;
this.currentYearLabelNode.innerHTML=_22;
this.nextYearLabelNode.innerHTML=_22+1;
};
this.getDateClassName=function(_23,_24){
var _25=this.classNames[_24];
if((!this.selectedIsUsed)&&(_23.getDate()==this.date.getDate())&&(_23.getMonth()==this.date.getMonth())&&(_23.getFullYear()==this.date.getFullYear())){
_25=this.classNames.selectedDate+" "+_25;
this.selectedIsUsed=1;
}
if((!this.currentIsUsed)&&(_23.getDate()==this.today.getDate())&&(_23.getMonth()==this.today.getMonth())&&(_23.getFullYear()==this.today.getFullYear())){
_25=_25+" "+this.classNames.currentDate;
this.currentIsUsed=1;
}
return _25;
};
this.onClick=function(evt){
dojo.event.browser.stopEvent(evt);
};
this.onSetDate=function(evt){
dojo.event.browser.stopEvent(evt);
this.selectedIsUsed=0;
this.todayIsUsed=0;
var _28=this.firstSaturday.month;
var _29=this.firstSaturday.year;
if(dojo.html.hasClass(evt.target,this.classNames["next"])){
_28=++_28%12;
_29=(_28==0)?++_29:_29;
}else{
if(dojo.html.hasClass(evt.target,this.classNames["previous"])){
_28=--_28%12;
_29=(_28==11)?--_29:_29;
}
}
this.date=new Date(_29,_28,evt.target.innerHTML);
this.setDate(dojo.widget.DatePicker.util.toRfcDate(this.date));
this.initUI();
};
};
dojo.inherits(dojo.widget.html.DatePicker,dojo.widget.HtmlWidget);

