dojo.provide("dojo.widget.html.Tooltip");
dojo.require("dojo.widget.HtmlWidget");
dojo.require("dojo.widget.Tooltip");
dojo.require("dojo.uri");
dojo.require("dojo.widget.*");
dojo.require("dojo.event");
dojo.require("dojo.style");
dojo.require("dojo.html");
dojo.widget.html.Tooltip=function(){
dojo.widget.Tooltip.call(this);
dojo.widget.HtmlWidget.call(this);
};
dojo.inherits(dojo.widget.html.Tooltip,dojo.widget.HtmlWidget);
dojo.lang.extend(dojo.widget.html.Tooltip,{caption:"undefined",delay:500,connectId:"",templatePath:dojo.uri.dojoUri("src/widget/templates/HtmlTooltipTemplate.html"),templateCssPath:dojo.uri.dojoUri("src/widget/templates/HtmlTooltipTemplate.css"),containerNode:null,connectNode:null,hovering:false,displayed:false,fillInTemplate:function(_1,_2){
if(this.caption!="undefined"){
this.domNode.appendChild(document.createTextNode(this.caption));
}
dojo.html.body().appendChild(this.domNode);
this.connectNode=dojo.byId(this.connectId);
this.bgIframe=new dojo.html.BackgroundIframe();
},postCreate:function(_3,_4){
var _5=this;
this.timerEvent=function(){
_5.display.apply(_5);
};
dojo.event.connect(this.connectNode,"onmouseover",this,"onMouseOver");
},onMouseOver:function(e){
if(this.displayed){
return;
}
this.timerEventId=setTimeout(this.timerEvent,this.delay);
dojo.event.connect(document.documentElement,"onmousemove",this,"onMouseMove");
},onMouseMove:function(e){
this.mouseX=e.pageX||e.clientX+dojo.html.body().scrollLeft;
this.mouseY=e.pageY||e.clientY+dojo.html.body().scrollTop;
if(!dojo.html.overElement(this.connectNode,e)){
this.erase();
}
},display:function(){
if(this.displayed){
return;
}
this.domNode.style.top=this.mouseY+15+"px";
this.domNode.style.left=this.mouseX+10+"px";
this.explodeSrc=[this.mouseX,this.mouseY];
this.show();
this.bgIframe.show(this.domNode);
this.displayed=true;
},onShow:function(){
this.bgIframe.show(this.domNode);
dojo.widget.html.Tooltip.superclass.onShow.call(this);
},erase:function(){
if(this.timerEventId){
clearTimeout(this.timerEventId);
delete this.timerEventId;
}
if(this.displayed){
this.hide();
this.bgIframe.hide();
this.displayed=false;
}
dojo.event.disconnect(document.documentElement,"onmousemove",this,"onMouseMove");
}});

