dojo.provide("dojo.date");
dojo.require("dojo.string");
dojo.date.setIso8601=function(_1,_2){
var _3=_2.split("T");
dojo.date.setIso8601Date(_1,_3[0]);
if(_3.length==2){
dojo.date.setIso8601Time(_1,_3[1]);
}
return _1;
};
dojo.date.fromIso8601=function(_4){
return dojo.date.setIso8601(new Date(0),_4);
};
dojo.date.setIso8601Date=function(_5,_6){
var _7="^([0-9]{4})((-?([0-9]{2})(-?([0-9]{2}))?)|"+"(-?([0-9]{3}))|(-?W([0-9]{2})(-?([1-7]))?))?$";
var d=_6.match(new RegExp(_7));
var _9=d[1];
var _a=d[4];
var _b=d[6];
var _c=d[8];
var _d=d[10];
var _e=(d[12])?d[12]:1;
_5.setYear(_9);
if(_c){
dojo.date.setDayOfYear(_5,Number(_c));
}else{
if(_d){
_5.setMonth(0);
_5.setDate(1);
var gd=_5.getDay();
var day=(gd)?gd:7;
var _11=Number(_e)+(7*Number(_d));
if(day<=4){
_5.setDate(_11+1-day);
}else{
_5.setDate(_11+8-day);
}
}else{
if(_a){
_5.setMonth(_a-1);
}
if(_b){
_5.setDate(_b);
}
}
}
return _5;
};
dojo.date.fromIso8601Date=function(_12){
return dojo.date.setIso8601Date(new Date(0),_12);
};
dojo.date.setIso8601Time=function(_13,_14){
var _15="Z|(([-+])([0-9]{2})(:?([0-9]{2}))?)$";
var d=_14.match(new RegExp(_15));
var _17=0;
if(d){
if(d[0]!="Z"){
_17=(Number(d[3])*60)+Number(d[5]);
_17*=((d[2]=="-")?1:-1);
}
_17-=_13.getTimezoneOffset();
_14=_14.substr(0,_14.length-d[0].length);
}
var _18="^([0-9]{2})(:?([0-9]{2})(:?([0-9]{2})(.([0-9]+))?)?)?$";
var d=_14.match(new RegExp(_18));
var _19=d[1];
var _1a=Number((d[3])?d[3]:0)+_17;
var _1b=(d[5])?d[5]:0;
var ms=d[7]?(Number("0."+d[7])*1000):0;
_13.setHours(_19);
_13.setMinutes(_1a);
_13.setSeconds(_1b);
_13.setMilliseconds(ms);
return _13;
};
dojo.date.fromIso8601Time=function(_1d){
return dojo.date.setIso8601Time(new Date(0),_1d);
};
dojo.date.setDayOfYear=function(_1e,_1f){
_1e.setMonth(0);
_1e.setDate(_1f);
return _1e;
};
dojo.date.getDayOfYear=function(_20){
var _21=new Date("1/1/"+_20.getFullYear());
return Math.floor((_20.getTime()-_21.getTime())/86400000);
};
dojo.date.getWeekOfYear=function(_22){
return Math.ceil(dojo.date.getDayOfYear(_22)/7);
};
dojo.date.daysInMonth=function(_23,_24){
dojo.deprecated("daysInMonth(month, year)","replaced by getDaysInMonth(dateObject)","0.4");
return dojo.date.getDaysInMonth(new Date(_24,_23,1));
};
dojo.date.getDaysInMonth=function(_25){
var _26=_25.getMonth();
var _27=_25.getFullYear();
var _28=[31,28,31,30,31,30,31,31,30,31,30,31];
if(_26==1&&_27){
if((!(_27%4)&&(_27%100))||(!(_27%4)&&!(_27%100)&&!(_27%400))){
return 29;
}else{
return 28;
}
}else{
return _28[_26];
}
};
dojo.date.months=["January","February","March","April","May","June","July","August","September","October","November","December"];
dojo.date.shortMonths=["Jan","Feb","Mar","Apr","May","June","July","Aug","Sep","Oct","Nov","Dec"];
dojo.date.days=["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"];
dojo.date.shortDays=["Sun","Mon","Tues","Wed","Thur","Fri","Sat"];
dojo.date.toLongDateString=function(_29){
return dojo.date.months[_29.getMonth()]+" "+_29.getDate()+", "+_29.getFullYear();
};
dojo.date.toShortDateString=function(_2a){
return dojo.date.shortMonths[_2a.getMonth()]+" "+_2a.getDate()+", "+_2a.getFullYear();
};
dojo.date.toMilitaryTimeString=function(_2b){
var h="00"+_2b.getHours();
var m="00"+_2b.getMinutes();
var s="00"+_2b.getSeconds();
return h.substr(h.length-2,2)+":"+m.substr(m.length-2,2)+":"+s.substr(s.length-2,2);
};
dojo.date.toRelativeString=function(_2f){
var now=new Date();
var _31=(now-_2f)/1000;
var end=" ago";
var _33=false;
if(_31<0){
_33=true;
end=" from now";
_31=-_31;
}
if(_31<60){
_31=Math.round(_31);
return _31+" second"+(_31==1?"":"s")+end;
}else{
if(_31<3600){
_31=Math.round(_31/60);
return _31+" minute"+(_31==1?"":"s")+end;
}else{
if(_31<3600*24&&_2f.getDay()==now.getDay()){
_31=Math.round(_31/3600);
return _31+" hour"+(_31==1?"":"s")+end;
}else{
if(_31<3600*24*7){
_31=Math.round(_31/(3600*24));
if(_31==1){
return _33?"Tomorrow":"Yesterday";
}else{
return _31+" days"+end;
}
}else{
return dojo.date.toShortDateString(_2f);
}
}
}
}
};
dojo.date.getDayOfWeekName=function(_34){
return dojo.date.days[_34.getDay()];
};
dojo.date.getShortDayOfWeekName=function(_35){
return dojo.date.shortDays[_35.getDay()];
};
dojo.date.getMonthName=function(_36){
return dojo.date.months[_36.getMonth()];
};
dojo.date.getShortMonthName=function(_37){
return dojo.date.shortMonths[_37.getMonth()];
};
dojo.date.toString=function(_38,_39){
if(_39.indexOf("#d")>-1){
_39=_39.replace(/#dddd/g,dojo.date.getDayOfWeekName(_38));
_39=_39.replace(/#ddd/g,dojo.date.getShortDayOfWeekName(_38));
_39=_39.replace(/#dd/g,(_38.getDate().toString().length==1?"0":"")+_38.getDate());
_39=_39.replace(/#d/g,_38.getDate());
}
if(_39.indexOf("#M")>-1){
_39=_39.replace(/#MMMM/g,dojo.date.getMonthName(_38));
_39=_39.replace(/#MMM/g,dojo.date.getShortMonthName(_38));
_39=_39.replace(/#MM/g,((_38.getMonth()+1).toString().length==1?"0":"")+(_38.getMonth()+1));
_39=_39.replace(/#M/g,_38.getMonth()+1);
}
if(_39.indexOf("#y")>-1){
var _3a=_38.getFullYear().toString();
_39=_39.replace(/#yyyy/g,_3a);
_39=_39.replace(/#yy/g,_3a.substring(2));
_39=_39.replace(/#y/g,_3a.substring(3));
}
if(_39.indexOf("#")==-1){
return _39;
}
if(_39.indexOf("#h")>-1){
var _3b=_38.getHours();
_3b=(_3b>12?_3b-12:(_3b==0)?12:_3b);
_39=_39.replace(/#hh/g,(_3b.toString().length==1?"0":"")+_3b);
_39=_39.replace(/#h/g,_3b);
}
if(_39.indexOf("#H")>-1){
_39=_39.replace(/#HH/g,(_38.getHours().toString().length==1?"0":"")+_38.getHours());
_39=_39.replace(/#H/g,_38.getHours());
}
if(_39.indexOf("#m")>-1){
_39=_39.replace(/#mm/g,(_38.getMinutes().toString().length==1?"0":"")+_38.getMinutes());
_39=_39.replace(/#m/g,_38.getMinutes());
}
if(_39.indexOf("#s")>-1){
_39=_39.replace(/#ss/g,(_38.getSeconds().toString().length==1?"0":"")+_38.getSeconds());
_39=_39.replace(/#s/g,_38.getSeconds());
}
if(_39.indexOf("#T")>-1){
_39=_39.replace(/#TT/g,_38.getHours()>=12?"PM":"AM");
_39=_39.replace(/#T/g,_38.getHours()>=12?"P":"A");
}
if(_39.indexOf("#t")>-1){
_39=_39.replace(/#tt/g,_38.getHours()>=12?"pm":"am");
_39=_39.replace(/#t/g,_38.getHours()>=12?"p":"a");
}
return _39;
};
dojo.date.toSql=function(_3c,_3d){
var sql=_3c.getFullYear()+"-"+dojo.string.pad(_3c.getMonth(),2)+"-"+dojo.string.pad(_3c.getDate(),2);
if(!_3d){
sql+=" "+dojo.string.pad(_3c.getHours(),2)+":"+dojo.string.pad(_3c.getMinutes(),2)+":"+dojo.string.pad(_3c.getSeconds(),2);
}
return sql;
};
dojo.date.fromSql=function(_3f){
var _40=_3f.split(/[\- :]/g);
while(_40.length<6){
_40.push(0);
}
return new Date(_40[0],_40[1],_40[2],_40[3],_40[4],_40[5]);
};

