dojo.provide("dojo.rpc.RpcService");
dojo.require("dojo.io.*");
dojo.require("dojo.json");
dojo.require("dojo.lang");
dojo.require("dojo.rpc.Deferred");
dojo.rpc.RpcService=function(_1){
if(_1){
this.connect(_1);
}
};
dojo.lang.extend(dojo.rpc.RpcService,{strictArgChecks:true,serviceUrl:"",parseResults:function(_2){
return _2;
},errorCallback:function(_3){
return function(_4,_5,e){
_3.errback(e);
};
},resultCallback:function(_7){
var tf=dojo.lang.hitch(this,function(_9,_a,e){
var _c=this.parseResults(_a);
_7.callback(_c);
});
return tf;
},generateMethod:function(_d,_e){
var _f=this;
return function(){
var _10=new dojo.rpc.Deferred();
if((!_f.strictArgChecks)||((_e!=null)&&(arguments.length!=_e.length))){
dojo.raise("Invalid number of parameters for remote method.");
}else{
_f.bind(_d,arguments,_10);
}
return _10;
};
},processSmd:function(_11){
dojo.debug("RpcService: Processing returned SMD.");
for(var n=0;n<_11.methods.length;n++){
dojo.debug("RpcService: Creating Method: this.",_11.methods[n].name,"()");
this[_11.methods[n].name]=this.generateMethod(_11.methods[n].name,_11.methods[n].parameters);
if(dojo.lang.isFunction(this[_11.methods[n].name])){
dojo.debug("RpcService: Successfully created",_11.methods[n].name,"()");
}else{
dojo.debug("RpcService: Failed to create",_11.methods[n].name,"()");
}
}
this.serviceUrl=_11.serviceUrl||_11.serviceURL;
dojo.debug("RpcService: Dojo RpcService is ready for use.");
},connect:function(_13){
dojo.debug("RpcService: Attempting to load SMD document from:",_13);
dojo.io.bind({url:_13,mimetype:"text/json",load:dojo.lang.hitch(this,function(_14,_15,e){
return this.processSmd(_15);
}),sync:true});
}});

