dojo.provide("dojo.widget.Dialog");
dojo.provide("dojo.widget.HtmlDialog");
dojo.require("dojo.widget.*");
dojo.require("dojo.event.*");
dojo.require("dojo.graphics.color");
dojo.require("dojo.fx.*");
dojo.require("dojo.html");
dojo.widget.tags.addParseTreeHandler("dojo:dialog");
dojo.widget.HtmlDialog=function(){
dojo.widget.HtmlWidget.call(this);
this.resizeConnectArgs={srcObj:window,srcFunc:"onresize",adviceObj:this,adviceFunc:"onResize",rate:500};
};
dojo.inherits(dojo.widget.HtmlDialog,dojo.widget.HtmlWidget);
dojo.lang.extend(dojo.widget.HtmlDialog,{templatePath:dojo.uri.dojoUri("src/widget/templates/HtmlDialog.html"),widgetType:"Dialog",isContainer:true,_scrollConnected:false,_resizeConnected:false,focusElement:"",effect:"fade",effectDuration:250,bg:null,bgIframe:null,bgColor:"black",bgOpacity:0.4,followScroll:1,_fromTrap:false,anim:null,trapTabs:function(e){
if(e.target==this.tabStart){
if(this._fromTrap){
this._fromTrap=false;
}else{
this._fromTrap=true;
this.tabEnd.focus();
}
}else{
if(e.target==this.tabEnd){
if(this._fromTrap){
this._fromTrap=false;
}else{
this._fromTrap=true;
this.tabStart.focus();
}
}
}
},clearTrap:function(e){
var _3=this;
setTimeout(function(){
_3._fromTrap=false;
},100);
},postCreate:function(_4,_5,_6){
with(this.domNode.style){
position="absolute";
zIndex=999;
display="none";
}
var b=dojo.html.body();
b.appendChild(this.domNode);
this.nodeRef=_5["dojo:"+this.widgetType.toLowerCase()]["nodeRef"];
if(this.nodeRef){
this.setContent(this.nodeRef);
}
this.bgIframe=new dojo.html.BackgroundIframe();
this.bg=document.createElement("div");
this.bg.className="dialogUnderlay";
with(this.bg.style){
position="absolute";
left=top="0px";
zIndex=998;
display="none";
}
this.setBackgroundColor(this.bgColor);
b.appendChild(this.bg);
this.bgIframe.setZIndex(this.bg);
},setContent:function(_8){
if(typeof _8=="string"){
this.containerNode.innerHTML=_8;
}else{
if(_8.nodeType!=undefined){
this.containerNode.appendChild(_8);
}else{
dojo.raise("Tried to setContent with unknown content ("+_8+")");
}
}
},setBackgroundColor:function(_9){
if(arguments.length>=3){
_9=new dojo.graphics.color.Color(arguments[0],arguments[1],arguments[2]);
}else{
_9=new dojo.graphics.color.Color(_9);
}
this.bg.style.backgroundColor=_9.toString();
return this.bgColor=_9;
},setBackgroundOpacity:function(op){
if(arguments.length==0){
op=this.bgOpacity;
}
dojo.style.setOpacity(this.bg,op);
try{
this.bgOpacity=dojo.style.getOpacity(this.bg);
}
catch(e){
this.bgOpacity=op;
}
return this.bgOpacity;
},sizeBackground:function(){
if(this.bgOpacity>0){
var h=document.documentElement.scrollHeight||dojo.html.body().scrollHeight;
var w=dojo.html.getViewportWidth();
this.bg.style.width=w+"px";
this.bg.style.height=h+"px";
this.bgIframe.size([0,0,w,h]);
}else{
this.bgIframe.size(this.domNode);
}
},showBackground:function(){
this.sizeBackground();
this.bgIframe.show();
if(this.bgOpacity>0){
this.bg.style.display="block";
}
},placeDialog:function(){
var _d=dojo.html.getScrollOffset();
var _e=dojo.html.getViewportSize();
this.domNode.style.display="block";
var w=this.domNode.offsetWidth;
var h=this.domNode.offsetHeight;
this.domNode.style.display="none";
var x=_d[0]+(_e[0]-w)/2;
var y=_d[1]+(_e[1]-h)/2;
with(this.domNode.style){
left=x+"px";
top=y+"px";
}
if(this.bgOpacity==0){
this.bgIframe.size([x,y,w,h]);
}
},show:function(){
this.setBackgroundOpacity();
this.placeDialog();
this.showBackground();
switch((this.effect||"").toLowerCase()){
case "fade":
this.domNode.style.display="block";
var _13=this;
if(this.anim){
this.anim.stop();
}
this.anim=dojo.fx.fade(this.domNode,this.effectDuration,0,1,dojo.lang.hitch(this,function(_14){
if(dojo.lang.isFunction(_13.onShow)){
_13.onShow(_14);
}
}));
break;
default:
this.domNode.style.display="block";
if(dojo.lang.isFunction(this.onShow)){
this.onShow(this.domNode);
}
break;
}
if(this.followScroll&&!this._scrollConnected){
this._scrollConnected=true;
dojo.event.connect(window,"onscroll",this,"onScroll");
}
if(!this._resizeConnected){
this._resizeConnected=true;
dojo.event.kwConnect(this.resizeConnectArgs);
}
},hide:function(){
if(this.focusElement){
dojo.byId(this.focusElement).focus();
dojo.byId(this.focusElement).blur();
}
switch((this.effect||"").toLowerCase()){
case "fade":
this.bg.style.display="none";
this.bgIframe.hide();
var _15=this;
if(this.anim){
this.anim.stop();
}
this.anim=dojo.fx.fadeOut(this.domNode,this.effectDuration,function(_16){
_16.style.display="none";
if(dojo.lang.isFunction(_15.onHide)){
_15.onHide(_16);
}
_15.anim=null;
});
break;
default:
this.bg.style.display="none";
this.bgIframe.hide();
this.domNode.style.display="none";
if(dojo.lang.isFunction(this.onHide)){
this.onHide(node);
}
break;
}
this.bg.style.width=this.bg.style.height="1px";
if(this._scrollConnected){
this._scrollConnected=false;
dojo.event.disconnect(window,"onscroll",this,"onScroll");
}
if(this._resizeConnected){
this._resizeConnected=false;
dojo.event.kwDisconnect(this.resizeConnectArgs);
}
},setCloseControl:function(_17){
dojo.event.connect(_17,"onclick",this,"hide");
},setShowControl:function(_18){
dojo.event.connect(_18,"onclick",this,"show");
},onScroll:function(){
this.placeDialog();
this.domNode.style.display="block";
},onResize:function(e){
this.sizeBackground();
}});

