dojo.provide("dojo.widget.FloatingPane");
dojo.provide("dojo.widget.html.FloatingPane");
dojo.require("dojo.widget.*");
dojo.require("dojo.widget.Manager");
dojo.require("dojo.html");
dojo.require("dojo.style");
dojo.require("dojo.dom");
dojo.require("dojo.widget.ContentPane");
dojo.require("dojo.widget.LayoutPane");
dojo.require("dojo.dnd.HtmlDragMove");
dojo.require("dojo.dnd.HtmlDragMoveSource");
dojo.require("dojo.dnd.HtmlDragMoveObject");
dojo.widget.html.FloatingPane=function(){
dojo.widget.html.LayoutPane.call(this);
};
dojo.inherits(dojo.widget.html.FloatingPane,dojo.widget.html.LayoutPane);
dojo.lang.extend(dojo.widget.html.FloatingPane,{widgetType:"FloatingPane",title:"",iconSrc:"",hasShadow:false,constrainToContainer:false,taskBarId:"",resizable:true,overflow:"",resizable:false,titleBarDisplay:"fancy",titleHeight:22,href:"",extractContent:true,parseContent:true,cacheContent:true,contentWrapper:"default",containerNode:null,domNode:null,clientPane:null,dragBar:null,windowState:"normal",displayCloseAction:false,maxTaskBarConnectAttempts:5,taskBarConnectAttempts:0,minimizeIcon:dojo.uri.dojoUri("src/widget/templates/images/floatingPaneMinimize.gif"),maximizeIcon:dojo.uri.dojoUri("src/widget/templates/images/floatingPaneMaximize.gif"),restoreIcon:dojo.uri.dojoUri("src/widget/templates/images/floatingPaneRestore.gif"),closeIcon:dojo.uri.dojoUri("src/widget/templates/images/floatingPaneClose.gif"),titleBarBackground:dojo.uri.dojoUri("src/widget/templates/images/titlebar-bg.jpg"),shadowPng:dojo.uri.dojoUri("src/widget/templates/images/shadow"),shadowThickness:8,shadowOffset:15,templateString:"<div></div>",templateCssPath:dojo.uri.dojoUri("src/widget/templates/HtmlFloatingPane.css"),initialized:false,addChild:function(_1,_2,_3,_4,_5){
this.clientPane.addChild(_1,_2,_3,_4,_5);
},_makeClientPane:function(_6){
var _7={layoutAlign:"client",id:this.widgetId+"_client",href:this.href,cacheContent:this.cacheContent,extractContent:this.extractContent,parseContent:this.parseContent};
var _8=this._createPane(this.contentWrapper=="layout"?"LayoutPane":"ContentPane",_6,_7);
return _8;
},fillInTemplate:function(_9,_a){
var _b=this.getFragNodeRef(_a);
this.domNode.style.cssText=_b.style.cssText;
dojo.html.addClass(this.domNode,dojo.html.getClass(_b));
dojo.html.addClass(this.domNode,"dojoFloatingPane");
this.domNode.style.position="absolute";
this.domNode.id=_b.id;
if(dojo.render.html.safari){
dojo.html.body().appendChild(this.domNode);
}
if(this.contentWrapper!="none"){
var _c=document.createElement("div");
dojo.dom.moveChildren(_b,_c,0);
this.clientPane=this._makeClientPane(_c);
}
if(this.titleBarDisplay!="none"){
var _d=document.createElement("div");
dojo.html.addClass(_d,"dojoFloatingPaneDragbar");
_d.style.height=this.titleHeight+"px";
this.dragBar=this._createPane("LayoutPane",_d,{layoutAlign:"top",id:this.widgetId+"_chrome"});
dojo.html.disableSelection(this.dragBar.domNode);
if(this.titleBarDisplay=="fancy"){
var _e=document.createElement("img");
_e.src=this.titleBarBackground;
dojo.html.addClass(_e,"dojoFloatingPaneDragbarBackground");
var _f=dojo.widget.createWidget("ContentPane",{layoutAlign:"flood",id:this.widgetId+"_titleBackground"},_e);
this.dragBar.addChild(_f);
}
var _10=document.createElement("div");
dojo.html.addClass(_10,"dojoFloatingPaneTitleBar");
dojo.html.disableSelection(_10);
var _11=document.createElement("div");
dojo.html.addClass(_11,"dojoFloatingPaneActions");
if(this.iconSrc!=""){
var _12=document.createElement("img");
dojo.html.addClass(_12,"dojoTitleBarIcon");
_12.src=this.iconSrc;
_10.appendChild(_12);
}
var _13=document.createTextNode(this.title);
_10.appendChild(_13);
if(this.resizable){
this.minimizeAction=document.createElement("img");
dojo.html.addClass(this.minimizeAction,"dojoFloatingPaneActionItem");
this.minimizeAction.src=this.minimizeIcon;
_11.appendChild(this.minimizeAction);
dojo.event.connect(this.minimizeAction,"onclick",this,"minimizeWindow");
this.restoreAction=document.createElement("img");
dojo.html.addClass(this.restoreAction,"dojoFloatingPaneActionItem");
this.restoreAction.src=this.restoreIcon;
_11.appendChild(this.restoreAction);
dojo.event.connect(this.restoreAction,"onclick",this,"restoreWindow");
if(this.windowState!="normal"){
this.restoreAction.style.display="inline";
}else{
this.restoreAction.style.display="none";
}
this.maximizeAction=document.createElement("img");
dojo.html.addClass(this.maximizeAction,"dojoFloatingPaneActionItem");
this.maximizeAction.src=this.maximizeIcon;
_11.appendChild(this.maximizeAction);
dojo.event.connect(this.maximizeAction,"onclick",this,"maximizeWindow");
if(this.windowState!="maximized"){
this.maximizeAction.style.display="inline";
}else{
this.maximizeAction.style.display="none";
}
}
if(this.displayCloseAction){
var _14=document.createElement("img");
dojo.html.addClass(_14,"dojoFloatingPaneActionItem");
_14.src=this.closeIcon;
_11.appendChild(_14);
dojo.event.connect(_14,"onclick",this,"closeWindow");
}
_d.appendChild(_10);
_d.appendChild(_11);
}
if(this.resizable){
var _15=document.createElement("div");
dojo.html.addClass(_15,"dojoFloatingPaneResizebar");
dojo.html.disableSelection(_15);
var rh=dojo.widget.createWidget("ResizeHandle",{targetElmId:this.widgetId,id:this.widgetId+"_resize"});
this.resizePane=this._createPane("ContentPane",_15,{layoutAlign:"bottom"});
this.resizePane.addChild(rh);
}
this._makeShadow();
dojo.event.connect(this.domNode,"onmousedown",this,"onMouseDown");
this.bgIframe=new dojo.html.BackgroundIframe();
if(this.bgIframe.iframe){
this.domNode.appendChild(this.bgIframe.iframe);
}
if(this.isVisible()){
this.bgIframe.show();
}
if(this.taskBarId){
this.taskBarSetup();
}
if(dojo.hostenv.post_load_){
this.setInitialWindowState();
}else{
dojo.addOnLoad(this,"setInitialWindowState");
}
if(dojo.render.html.safari){
dojo.html.body().removeChild(this.domNode);
}
dojo.widget.html.FloatingPane.superclass.postCreate.call(this,_9,_a);
},postCreate:function(_17,_18){
if(this.contentWrapper=="none"){
this.clientPane=this.children[0];
this.domNode.appendChild(this.clientPane.domNode);
}else{
var _19=this.children.concat();
this.children=[];
for(var i=0;i<_19.length;i++){
if(_19[i].ownerPane==this){
this.children.push(_19[i]);
}else{
if(this.contentWrapper=="layout"){
this.clientPane.addChild(_19[i]);
}else{
this.clientPane.children.push(_19[i]);
}
}
}
}
dojo.html.addClass(this.clientPane.domNode,"dojoFloatingPaneClient");
this.clientPane.layoutAlign="client";
this.clientPane.ownerPane=this;
if(this.overflow!=""){
this.clientPane.domNode.style.overflow=this.overflow;
}
if(this.titleBarDisplay!="none"){
var _1b=new dojo.dnd.HtmlDragMoveSource(this.domNode);
if(this.constrainToContainer){
_1b.constrainTo();
}
_1b.setDragHandle(this.dragBar.domNode);
}
this.initialized=true;
},_makeShadow:function(){
if(this.hasShadow){
this.shadow={};
var x1=-1*this.shadowThickness;
var y0=this.shadowOffset;
var y1=this.shadowOffset+this.shadowThickness;
this._makeShadowPiece("ul","top",y0,"left",x1);
this._makeShadowPiece("l","top",y1,"left",x1,"scale");
this._makeShadowPiece("ur","top",y0,"left",0);
this._makeShadowPiece("r","top",y1,"left",0,"scale");
this._makeShadowPiece("bl","top",0,"left",x1);
this._makeShadowPiece("b","top",0,"left",0,"crop");
this._makeShadowPiece("br","top",0,"left",0);
}
},_makeShadowPiece:function(_1f,_20,_21,_22,_23,_24){
var img;
var url=this.shadowPng+_1f.toUpperCase()+".png";
if(dojo.render.html.ie){
img=document.createElement("div");
img.style.filter="progid:DXImageTransform.Microsoft.AlphaImageLoader(src='"+url+"'"+(_24?", sizingMethod='"+_24+"'":"")+")";
}else{
img=document.createElement("img");
img.src=url;
}
img.style.position="absolute";
img.style[_20]=_21+"px";
img.style[_22]=_23+"px";
img.style.width=this.shadowThickness+"px";
img.style.height=this.shadowThickness+"px";
this.shadow[_1f]=img;
this.domNode.appendChild(img);
},_sizeShadow:function(_27,_28){
if(this.shadow){
var _29=_28-(this.shadowOffset+this.shadowThickness+1);
this.shadow.l.style.height=_29+"px";
this.shadow.r.style.height=_29+"px";
this.shadow.b.style.width=(_27-1)+"px";
this.shadow.bl.style.top=(_28-1)+"px";
this.shadow.b.style.top=(_28-1)+"px";
this.shadow.br.style.top=(_28-1)+"px";
this.shadow.ur.style.left=(_27-1)+"px";
this.shadow.r.style.left=(_27-1)+"px";
this.shadow.br.style.left=(_27-1)+"px";
}
},maximizeWindow:function(evt){
this.previousWidth=this.domNode.style.width;
this.previousHeight=this.domNode.style.height;
this.previousLeft=this.domNode.style.left;
this.previousTop=this.domNode.style.top;
this.domNode.style.left=dojo.style.getPixelValue(this.domNode.parentNode,"padding-left",true)+"px";
this.domNode.style.top=dojo.style.getPixelValue(this.domNode.parentNode,"padding-top",true)+"px";
if((this.domNode.parentNode.nodeName.toLowerCase()=="body")){
dojo.style.setOuterWidth(this.domNode,dojo.html.getViewportWidth()-dojo.style.getPaddingWidth(dojo.html.body()));
dojo.style.setOuterHeight(this.domNode,dojo.html.getViewportHeight()-dojo.style.getPaddingHeight(dojo.html.body()));
}else{
dojo.style.setOuterWidth(this.domNode,dojo.style.getContentWidth(this.domNode.parentNode));
dojo.style.setOuterHeight(this.domNode,dojo.style.getContentHeight(this.domNode.parentNode));
}
this.maximizeAction.style.display="none";
this.restoreAction.style.display="inline";
this.windowState="maximized";
this.onResized();
},minimizeWindow:function(evt){
this.hide();
if(this.resizable){
this.maximizeAction.style.display="inline";
this.restoreAction.style.display="inline";
}
this.windowState="minimized";
},restoreWindow:function(evt){
if(this.previousWidth&&this.previousHeight&&this.previousLeft&&this.previousTop){
this.domNode.style.width=this.previousWidth;
this.domNode.style.height=this.previousHeight;
this.domNode.style.left=this.previousLeft;
this.domNode.style.top=this.previousTop;
dojo.widget.html.FloatingPane.superclass.onResized.call(this);
}
if(this.widgetState!="maximized"){
this.show();
}
if(this.resizable){
this.maximizeAction.style.display="inline";
this.restoreAction.style.display="none";
}
this.bringToTop();
this.windowState="normal";
},closeWindow:function(evt){
this.destroy();
},onMouseDown:function(evt){
this.bringToTop();
},bringToTop:function(){
var _2f=100;
var _30=dojo.widget.manager.getWidgetsByType("FloatingPane");
var _31=[];
var y=0;
for(var x=0;x<_30.length;x++){
if(this.widgetId!=_30[x].widgetId){
_31.push(_30[x]);
}
}
_31.sort(function(a,b){
return a.domNode.style.zIndex-b.domNode.style.zIndex;
});
_31.push(this);
for(x=0;x<_31.length;x++){
_31[x].domNode.style.zIndex=_2f+x;
}
},setInitialWindowState:function(){
if(this.windowState=="maximized"){
this.maximizeWindow();
this.show();
this.bringToTop();
return;
}
if(this.windowState=="normal"){
dojo.lang.setTimeout(this,this.onResized,50);
this.show();
this.bringToTop();
return;
}
if(this.windowState=="minimized"){
this.hide();
return;
}
this.windowState="minimized";
},taskBarSetup:function(){
var _36=dojo.widget.getWidgetById(this.taskBarId);
if(!_36){
if(this.taskBarConnectAttempts<this.maxTaskBarConnectAttempts){
dojo.lang.setTimeout(this,this.taskBarSetup,50);
this.taskBarConnectAttempts++;
}else{
dojo.debug("Unable to connect to the taskBar");
}
return;
}
_36.addChild(this);
},onResized:function(){
if(!this.isVisible()){
return;
}
var _37=dojo.style.getInnerHeight(this.domNode);
var _38=dojo.style.getInnerWidth(this.domNode);
this.width=_38;
this.height=_37;
this._sizeShadow(_38,_37);
dojo.widget.html.FloatingPane.superclass.onResized.call(this);
if(this.bgIframe){
this.bgIframe.size([0,0,_38,_37]);
}
},hide:function(){
dojo.widget.html.FloatingPane.superclass.hide.call(this);
if(this.bgIframe){
this.bgIframe.hide();
}
},show:function(){
dojo.widget.html.FloatingPane.superclass.show.call(this);
if(this.bgIframe){
this.bgIframe.show();
}
},_createPane:function(_39,_3a,_3b){
var _3c=dojo.widget.createWidget(_39,_3b,_3a);
dojo.widget.html.FloatingPane.superclass.addChild.call(this,_3c);
_3c.ownerPane=this;
return _3c;
},setUrl:function(url){
this.clientPane.setUrl(url);
},setContent:function(str){
this.clientPane.setContent(str);
}});
dojo.widget.tags.addParseTreeHandler("dojo:FloatingPane");

