dojo.provide("dojo.widget.SlideShow");
dojo.provide("dojo.widget.html.SlideShow");
dojo.require("dojo.event");
dojo.require("dojo.widget.*");
dojo.require("dojo.fx.html");
dojo.require("dojo.style");
dojo.widget.html.SlideShow=function(){
dojo.widget.HtmlWidget.call(this);
this.templatePath=dojo.uri.dojoUri("src/widget/templates/HtmlSlideShow.html");
this.templateCssPath=dojo.uri.dojoUri("src/widget/templates/HtmlSlideShow.css");
this.isContainer=false;
this.widgetType="SlideShow";
this.imgUrls=[];
this.imgUrlBase="";
this.urlsIdx=0;
this.delay=4000;
this.transitionInterval=2000;
this.imgWidth=800;
this.imgHeight=600;
this.background="img2";
this.foreground="img1";
this.stopped=false;
this.fadeAnim=null;
this.imagesContainer=null;
this.startStopButton=null;
this.controlsContainer=null;
this.img1=null;
this.img2=null;
this.fillInTemplate=function(){
dojo.style.setOpacity(this.img1,0.9999);
dojo.style.setOpacity(this.img2,0.9999);
with(this.imagesContainer.style){
width=this.imgWidth+"px";
height=this.imgHeight+"px";
}
with(this.img1.style){
width=this.imgWidth+"px";
height=this.imgHeight+"px";
}
with(this.img2.style){
width=this.imgWidth+"px";
height=this.imgHeight+"px";
}
if(this.imgUrls.length>1){
this.img2.src=this.imgUrlBase+this.imgUrls[this.urlsIdx++];
this.endTransition();
}else{
this.img1.src=this.imgUrlBase+this.imgUrls[this.urlsIdx++];
}
};
this.togglePaused=function(){
if(this.stopped){
this.stopped=false;
this.endTransition();
this.startStopButton.value="pause";
}else{
this.stopped=true;
this.startStopButton.value="play";
}
};
this.backgroundImageLoaded=function(){
if(this.stopped){
return;
}
var _1=this;
var _2=function(){
_1.endTransition();
};
if(this.fadeAnim){
this.fadeAnim.stop();
}
this.fadeAnim=dojo.fx.html.fadeOut(this[this.foreground],this.transitionInterval,_2);
};
this.endTransition=function(){
with(this[this.background].style){
zIndex=parseInt(zIndex)+1;
}
with(this[this.foreground].style){
zIndex=parseInt(zIndex)-1;
}
var _3=this.foreground;
this.foreground=this.background;
this.background=_3;
this.loadNextImage();
};
this.loadNextImage=function(){
dojo.event.kwConnect({srcObj:this[this.background],srcFunc:"onload",adviceObj:this,adviceFunc:"backgroundImageLoaded",once:true,delay:this.delay});
dojo.style.setOpacity(this[this.background],1);
this[this.background].src=this.imgUrlBase+this.imgUrls[this.urlsIdx++];
if(this.urlsIdx>(this.imgUrls.length-1)){
this.urlsIdx=0;
}
};
};
dojo.inherits(dojo.widget.html.SlideShow,dojo.widget.HtmlWidget);
dojo.widget.tags.addParseTreeHandler("dojo:slideshow");

