dojo.provide("dojo.widget.LayoutPane");
dojo.provide("dojo.widget.html.LayoutPane");
dojo.require("dojo.widget.LayoutPane");
dojo.require("dojo.widget.*");
dojo.require("dojo.event.*");
dojo.require("dojo.io.*");
dojo.require("dojo.widget.Container");
dojo.require("dojo.html");
dojo.require("dojo.style");
dojo.require("dojo.dom");
dojo.require("dojo.string");
dojo.widget.html.LayoutPane=function(){
dojo.widget.html.Container.call(this);
};
dojo.inherits(dojo.widget.html.LayoutPane,dojo.widget.html.Container);
dojo.lang.extend(dojo.widget.html.LayoutPane,{widgetType:"LayoutPane",isChild:false,clientWidth:0,clientHeight:0,layoutChildPriority:"top-bottom",cssPath:dojo.uri.dojoUri("src/widget/templates/HtmlLayoutPane.css"),url:"inline",extractContent:true,parseContent:true,cacheContent:true,handler:"none",minWidth:0,minHeight:0,fillInTemplate:function(){
this.filterAllowed(this,"layoutChildPriority",["left-right","top-bottom"]);
dojo.style.insertCssFile(this.cssPath,null,true);
dojo.html.addClass(this.domNode,"dojoLayoutPane");
},postCreate:function(_1,_2,_3){
for(var i=0;i<this.children.length;i++){
this._injectChild(this.children[i]);
}
if(this.handler!="none"){
this.setHandler(this.handler);
}
if(this.isVisible()){
this.loadContents();
}
},loadContents:function(){
if(this.isLoaded){
return;
}
if(dojo.lang.isFunction(this.handler)){
this._runHandler();
}else{
if(this.url!="inline"){
this._downloadExternalContent(this.url,this.cacheContent);
}
}
this.isLoaded=true;
},setUrl:function(_5){
this.url=_5;
this.isLoaded=false;
if(this.isVisible()){
this.loadContents();
}
},_downloadExternalContent:function(_6,_7){
dojo.deprecated("LayoutPane url parameter.","use LinkPane to download from a URL","0.4");
var _8=this.containerNode||this.domNode;
_8.innerHTML="Loading...";
var _9=this.extractContent;
var _a=this.parseContent;
var _b=this;
dojo.io.bind({url:_6,useCache:_7,mimetype:"text/html",handler:function(_c,_d,e){
if(_c=="load"){
if(_9){
var _f=_d.match(/<body[^>]*>\s*([\s\S]+)\s*<\/body>/im);
if(_f){
_d=_f[1];
}
}
_8.innerHTML=_d;
if(_a){
var _10=new dojo.xml.Parse();
var _11=_10.parseElement(_8,null,true);
dojo.widget.getParser().createComponents(_11);
}
_b.onResized();
}else{
_8.innerHTML="Error loading '"+_6+"' ("+e.status+" "+e.statusText+")";
}
}});
},setHandler:function(_12){
var fcn=dojo.lang.isFunction(_12)?_12:window[_12];
if(!dojo.lang.isFunction(fcn)){
throw new Error("Unable to set handler, '"+_12+"' not a function.");
return;
}
this.handler=function(){
return fcn.apply(this,arguments);
};
},_runHandler:function(){
if(dojo.lang.isFunction(this.handler)){
dojo.deprecated("use LinkPane to download content from a java function","0.4");
this.handler(this,this.domNode);
return false;
}
return true;
},filterAllowed:function(_14,_15,_16){
if(!dojo.lang.inArray(_16,_14[_15])){
_14[_15]=_16[0];
}
},layoutChildren:function(){
var _17={"left":[],"right":[],"top":[],"bottom":[],"client":[],"flood":[]};
var _18=0;
for(var i=0;i<this.children.length;i++){
if(this.hasLayoutAlign(this.children[i])){
_17[this.children[i].layoutAlign].push(this.children[i]);
_18++;
}
}
if(!_18){
return;
}
var _1a=this.containerNode||this.domNode;
this.clientWidth=dojo.style.getContentWidth(_1a);
this.clientHeight=dojo.style.getContentHeight(_1a);
this.clientRect={};
this.clientRect["left"]=dojo.style.getPixelValue(_1a,"padding-left",true);
this.clientRect["right"]=dojo.style.getPixelValue(_1a,"padding-right",true);
this.clientRect["top"]=dojo.style.getPixelValue(_1a,"padding-top",true);
this.clientRect["bottom"]=dojo.style.getPixelValue(_1a,"padding-bottom",true);
this._layoutCenter(_17,"flood");
if(this.layoutChildPriority=="top-bottom"){
this._layoutFloat(_17,"top");
this._layoutFloat(_17,"bottom");
this._layoutFloat(_17,"left");
this._layoutFloat(_17,"right");
}else{
this._layoutFloat(_17,"left");
this._layoutFloat(_17,"right");
this._layoutFloat(_17,"top");
this._layoutFloat(_17,"bottom");
}
this._layoutCenter(_17,"client");
},_layoutFloat:function(_1b,_1c){
var ary=_1b[_1c];
var lr=(_1c=="right")?"right":"left";
var tb=(_1c=="bottom")?"bottom":"top";
for(var i=0;i<ary.length;i++){
var elm=ary[i];
elm.domNode.style[lr]=this.clientRect[lr]+"px";
elm.domNode.style[tb]=this.clientRect[tb]+"px";
if((_1c=="top")||(_1c=="bottom")){
dojo.style.setOuterWidth(elm.domNode,this.clientWidth);
var _22=dojo.style.getOuterHeight(elm.domNode);
this.clientHeight-=_22;
this.clientRect[_1c]+=_22;
}else{
dojo.style.setOuterHeight(elm.domNode,this.clientHeight);
var _23=dojo.style.getOuterWidth(elm.domNode);
this.clientWidth-=_23;
this.clientRect[_1c]+=_23;
}
}
},_layoutCenter:function(_24,_25){
var ary=_24[_25];
for(var i=0;i<ary.length;i++){
var elm=ary[i];
elm.domNode.style.left=this.clientRect.left+"px";
elm.domNode.style.top=this.clientRect.top+"px";
dojo.style.setOuterWidth(elm.domNode,this.clientWidth);
dojo.style.setOuterHeight(elm.domNode,this.clientHeight);
}
},hasLayoutAlign:function(_29){
return dojo.lang.inArray(["left","right","top","bottom","client","flood"],_29.layoutAlign);
},addChild:function(_2a,_2b,pos,ref,_2e){
this._injectChild(_2a);
dojo.widget.html.LayoutPane.superclass.addChild.call(this,_2a,_2b,pos,ref,_2e);
this.resizeSoon();
},_injectChild:function(_2f){
if(this.hasLayoutAlign(_2f)){
_2f.domNode.style.position="absolute";
_2f.isChild=true;
this.filterAllowed(_2f,"layoutAlign",["none","left","top","right","bottom","client","flood"]);
dojo.html.addClass(_2f.domNode,"dojoAlign"+dojo.string.capitalize(_2f.layoutAlign));
}
},removeChild:function(_30){
dojo.widget.html.LayoutPane.superclass.removeChild.call(this,_30);
dojo.dom.removeNode(_30.domNode);
this.resizeSoon();
},onResized:function(){
if(!this.isVisible()){
return;
}
this.layoutChildren();
this.notifyChildrenOfResize();
},resizeTo:function(w,h){
w=Math.max(w,this.getMinWidth());
h=Math.max(h,this.getMinHeight());
dojo.style.setOuterWidth(this.domNode,w);
dojo.style.setOuterHeight(this.domNode,h);
this.onResized();
},show:function(){
this.loadContents();
this.domNode.style.display="";
this.onResized();
this.domNode.style.display="none";
this.domNode.style.visibility="";
dojo.widget.html.LayoutPane.superclass.show.call(this);
},getMinWidth:function(){
var w=this.minWidth;
if((this.layoutAlign=="left")||(this.layoutAlign=="right")){
w=dojo.style.getOuterWidth(this.domNode);
}
for(var i=0;i<this.children.length;i++){
var ch=this.children[i];
var a=ch.layoutAlign;
if((a=="left")||(a=="right")||(a=="client")){
if(dojo.lang.isFunction(ch.getMinWidth)){
w+=ch.getMinWidth();
}
}
}
for(var i=0;i<this.children.length;i++){
var ch=this.children[i];
var a=ch.layoutAlign;
if((a=="top")||(a=="bottom")){
if(dojo.lang.isFunction(ch.getMinWidth)){
w=Math.max(w,ch.getMinWidth());
}
}
}
return w;
},getMinHeight:function(){
var h=this.minHeight;
if((this.layoutAlign=="top")||(this.layoutAlign=="bottom")){
h=dojo.style.getOuterHeight(this.domNode);
}
for(var i=0;i<this.children.length;i++){
var ch=this.children[i];
var a=ch.layoutAlign;
if((a=="top")||(a=="bottom")||(a=="client")){
if(dojo.lang.isFunction(ch.getMinHeight)){
h+=ch.getMinHeight();
}
}
}
for(var i=0;i<this.children.length;i++){
var ch=this.children[i];
var a=ch.layoutAlign;
if((a=="left")||(a=="right")){
if(dojo.lang.isFunction(ch.getMinHeight)){
h=Math.max(h,ch.getMinHeight());
}
}
}
return h;
}});
dojo.lang.extend(dojo.widget.Widget,{layoutAlign:"none"});

