dojo.provide("dojo.widget.html.TimePicker");
dojo.require("dojo.widget.*");
dojo.require("dojo.widget.HtmlWidget");
dojo.require("dojo.widget.TimePicker");
dojo.require("dojo.widget.TimePicker.util");
dojo.require("dojo.event.*");
dojo.require("dojo.html");
dojo.widget.html.TimePicker=function(){
dojo.widget.TimePicker.call(this);
dojo.widget.HtmlWidget.call(this);
var _1=this;
this.time="";
this.useDefaultTime=false;
this.useDefaultMinutes=false;
this.storedTime="";
this.currentTime={};
this.classNames={selectedTime:"selectedItem"};
this.any="any";
this.selectedTime={hour:"",minute:"",amPm:"",anyTime:false};
this.hourIndexMap=["",2,4,6,8,10,1,3,5,7,9,11,0];
this.minuteIndexMap=[0,2,4,6,8,10,1,3,5,7,9,11];
this.templatePath=dojo.uri.dojoUri("src/widget/templates/HtmlTimePicker.html");
this.templateCssPath=dojo.uri.dojoUri("src/widget/templates/HtmlTimePicker.css");
this.fillInTemplate=function(){
this.initData();
this.initUI();
};
this.initData=function(){
if(this.storedTime.split("T")[1]&&this.storedTime!=" "&&this.storedTime.split("T")[1]!="any"){
this.time=dojo.widget.TimePicker.util.fromRfcDateTime(this.storedTime,this.useDefaultMinutes);
}else{
if(this.useDefaultTime){
this.time=dojo.widget.TimePicker.util.fromRfcDateTime("",this.useDefaultMinutes);
}else{
this.selectedTime.anyTime=true;
}
}
};
this.initUI=function(){
if(this.time){
var _2=dojo.widget.TimePicker.util.toAmPmHour(this.time.getHours());
var _3=_2[0];
var _4=_2[1];
var _5=this.time.getMinutes();
var _6=parseInt(_5/5);
this.onSetSelectedHour(this.hourIndexMap[_3]);
this.onSetSelectedMinute(this.minuteIndexMap[_6]);
this.onSetSelectedAmPm(_4);
}else{
this.onSetSelectedAnyTime();
}
};
this.setDateTime=function(_7){
this.storedTime=_7;
};
this.onClearSelectedHour=function(_8){
this.clearSelectedHour();
};
this.onClearSelectedMinute=function(_9){
this.clearSelectedMinute();
};
this.onClearSelectedAmPm=function(_a){
this.clearSelectedAmPm();
};
this.onClearSelectedAnyTime=function(_b){
this.clearSelectedAnyTime();
if(this.selectedTime.anyTime){
this.selectedTime.anyTime=false;
this.time=dojo.widget.TimePicker.util.fromRfcDateTime("",this.useDefaultMinutes);
this.initUI();
}
};
this.clearSelectedHour=function(){
var _c=this.hourContainerNode.getElementsByTagName("td");
for(var i=0;i<_c.length;i++){
dojo.html.setClass(_c.item(i),"");
}
};
this.clearSelectedMinute=function(){
var _e=this.minuteContainerNode.getElementsByTagName("td");
for(var i=0;i<_e.length;i++){
dojo.html.setClass(_e.item(i),"");
}
};
this.clearSelectedAmPm=function(){
var _10=this.amPmContainerNode.getElementsByTagName("td");
for(var i=0;i<_10.length;i++){
dojo.html.setClass(_10.item(i),"");
}
};
this.clearSelectedAnyTime=function(){
dojo.html.setClass(this.anyTimeContainerNode,"anyTimeContainer");
};
this.onSetSelectedHour=function(evt){
this.onClearSelectedAnyTime();
this.onClearSelectedHour();
this.setSelectedHour(evt);
this.onSetTime();
};
this.setSelectedHour=function(evt){
if(evt&&evt.target){
dojo.html.setClass(evt.target,this.classNames.selectedTime);
this.selectedTime["hour"]=evt.target.innerHTML;
}else{
if(!isNaN(evt)){
var _14=this.hourContainerNode.getElementsByTagName("td");
if(_14.item(evt)){
dojo.html.setClass(_14.item(evt),this.classNames.selectedTime);
this.selectedTime["hour"]=_14.item(evt).innerHTML;
}
}
}
this.selectedTime.anyTime=false;
};
this.onSetSelectedMinute=function(evt){
this.onClearSelectedAnyTime();
this.onClearSelectedMinute();
this.setSelectedMinute(evt);
this.selectedTime.anyTime=false;
this.onSetTime();
};
this.setSelectedMinute=function(evt){
if(evt&&evt.target){
dojo.html.setClass(evt.target,this.classNames.selectedTime);
this.selectedTime["minute"]=evt.target.innerHTML;
}else{
if(!isNaN(evt)){
var _17=this.minuteContainerNode.getElementsByTagName("td");
if(_17.item(evt)){
dojo.html.setClass(_17.item(evt),this.classNames.selectedTime);
this.selectedTime["minute"]=_17.item(evt).innerHTML;
}
}
}
};
this.onSetSelectedAmPm=function(evt){
this.onClearSelectedAnyTime();
this.onClearSelectedAmPm();
this.setSelectedAmPm(evt);
this.selectedTime.anyTime=false;
this.onSetTime();
};
this.setSelectedAmPm=function(evt){
if(evt&&evt.target){
dojo.html.setClass(evt.target,this.classNames.selectedTime);
this.selectedTime["amPm"]=evt.target.innerHTML;
}else{
evt=evt?0:1;
var _1a=this.amPmContainerNode.getElementsByTagName("td");
if(_1a.item(evt)){
dojo.html.setClass(_1a.item(evt),this.classNames.selectedTime);
this.selectedTime["amPm"]=_1a.item(evt).innerHTML;
}
}
};
this.onSetSelectedAnyTime=function(evt){
this.onClearSelectedHour();
this.onClearSelectedMinute();
this.onClearSelectedAmPm();
this.setSelectedAnyTime();
this.onSetTime();
};
this.setSelectedAnyTime=function(evt){
this.selectedTime.anyTime=true;
dojo.html.setClass(this.anyTimeContainerNode,this.classNames.selectedTime+" "+"anyTimeContainer");
};
this.onClick=function(evt){
dojo.event.browser.stopEvent(evt);
};
this.onSetTime=function(){
if(this.selectedTime.anyTime){
this.time=new Date();
var _1e=dojo.widget.TimePicker.util.toRfcDateTime(this.time);
this.setDateTime(_1e.split("T")[0]+"T"+this.any);
}else{
var _1f=12;
var _20=0;
var _21=false;
if(this.selectedTime["hour"]){
_1f=parseInt(this.selectedTime["hour"],10);
}
if(this.selectedTime["minute"]){
_20=parseInt(this.selectedTime["minute"],10);
}
if(this.selectedTime["amPm"]){
_21=(this.selectedTime["amPm"].toLowerCase()=="am");
}
this.time=new Date();
this.time.setHours(dojo.widget.TimePicker.util.fromAmPmHour(_1f,_21));
this.time.setMinutes(_20);
this.setDateTime(dojo.widget.TimePicker.util.toRfcDateTime(this.time));
}
};
};
dojo.inherits(dojo.widget.html.TimePicker,dojo.widget.HtmlWidget);

