dojo.provide("dojo.widget.svg.HslColorPicker");
dojo.require("dojo.widget.HtmlWidget");
dojo.require("dojo.widget.HslColorPicker");
dojo.require("dojo.math");
dojo.require("dojo.svg");
dojo.require("dojo.graphics.color");
dojo.widget.svg.HslColorPicker=function(){
dojo.widget.HslColorPicker.call(this);
dojo.widget.HtmlWidget.call(this);
dojo.debug("warning: the HslColorPicker is not a finished widget, and is not yet ready for general use");
this.hue="0";
this.saturation="0";
this.light="0";
this.storedColor="#0054aa";
var _1=this;
this.filterObject={};
};
dojo.inherits(dojo.widget.svg.HslColorPicker,dojo.widget.HtmlWidget);
dojo.lang.extend(dojo.widget.svg.HslColorPicker,{templatePath:dojo.uri.dojoUri("src/widget/templates/HslColorPicker.svg"),templateCssPath:dojo.uri.dojoUri("src/widget/templates/HslColorPicker.css"),fillInTemplate:function(){
this.height="131px";
this.svgDoc=this.hueNode.ownerDocument;
this.leftGradientColorNode=this.hueNode.ownerDocument.getElementById("leftGradientColor");
this.rightGradientColorNode=this.hueNode.ownerDocument.getElementById("rightGradientColor");
this.hueNode.setAttributeNS(dojo.dom.xmlns.xlink,"href",dojo.uri.dojoUri("src/widget/templates/images/hue.png"));
var _2=dojo.graphics.color.hex2hsl(this.storedColor);
this.hue=_2[0];
this.saturation=_2[1];
this.light=_2[2];
this.setSaturationStopColors();
},setSaturationStopColors:function(){
this.leftGradientStopColor=dojo.graphics.color.rgb2hex(this.hsl2rgb(this.hue,0,50));
this.rightGradientStopColor=dojo.graphics.color.rgb2hex(this.hsl2rgb(this.hue,100,50));
this.leftGradientColorNode.setAttributeNS(null,"stop-color",this.leftGradientStopColor);
this.rightGradientColorNode.setAttributeNS(null,"stop-color",this.rightGradientStopColor);
},setHue:function(_3){
this.hue=_3;
},setHueSlider:function(){
this.hueSliderNode.setAttribute("y",parseInt((this.hue/360)*parseInt(this.height)-2)+"px");
},setSaturationLight:function(_4,_5){
this.saturation=_4;
this.light=_5;
},setSaturationLightSlider:function(){
},onHueClick:function(_6){
var _7=parseInt(_6.clientY)-parseInt(_6.target.getAttribute("y"));
this.setHue(360-parseInt(_7*(360/parseInt(this.height))));
this.setSaturationStopColors();
this.setStoredColor(dojo.graphics.color.hsl2hex(this.hue,this.saturation,this.light));
},onHueDrag:function(_8){
},onSaturationLightClick:function(_9){
var _a=parseInt(_9.clientX)-parseInt(_9.target.getAttribute("y"));
var _b=parseInt(_9.clientY)-parseInt(_9.target.getAttribute("y"));
saturation=parseInt(parseInt(_a)*(101/106));
light=parseInt(parseInt(_b)*(101/106));
this.setSaturationLight(saturation,light);
this.setStoredColor(dojo.graphics.color.hsl2hex(this.hue,this.saturation,this.light));
},onSaturationLightDrag:function(_c){
},getStoredColor:function(){
return this.storedColor;
},setStoredColor:function(_d){
this.storedColor=_d;
dojo.event.topic.publish("/"+this.widgetId+"/setStoredColor",this.filterObject);
},hsl2rgb:function(_e,_f,_10){
function rgb(q1,q2,hue){
if(hue>360){
hue=hue-360;
}
if(hue<0){
hue=hue+360;
}
if(hue<60){
return (q1+(q2-q1)*hue/60);
}else{
if(hue<180){
return (q2);
}else{
if(hue<240){
return (q1+(q2-q1)*(240-hue)/60);
}else{
return (q1);
}
}
}
}
this.rgb=rgb;
if(_f==0){
return [Math.round(_10*255/100),Math.round(_10*255/100),Math.round(_10*255/100)];
}else{
_10=_10/100;
_f=_f/100;
if((_10)<0.5){
var _14=(_10)*(1+_f);
}else{
var _14=(_10+_f-(_10*_f));
}
temp1=2*_10-_14;
var _15=[];
_15[0]=Math.round(rgb(temp1,_14,parseInt(_e)+120)*255);
_15[1]=Math.round(rgb(temp1,_14,_e)*255);
_15[2]=Math.round(rgb(temp1,_14,parseInt(_e)-120)*255);
return _15;
}
}});

